--
-- Definition of a single port ROM for KCPSM-II program defined by iff1.psm
-- and assmbled using KCPSM2 assembler.
--
--CB Modified to allow the KCPSM-II to read and write the program space
--
-- Standard IEEE libraries
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--
-- The Unisim Library is used to define Xilinx primitives. It is also used during
-- simulation. The source can be viewed at %XILINX%\vhdl\src\unisims\unisim_VCOMP.vhd
--  
library unisim;
use unisim.vcomponents.all;
--
--
entity iff1 is
    Port (      address : in std_logic_vector(9 downto 0);
            instruction : out std_logic_vector(17 downto 0);
                     di : in std_logic_vector(8 downto 0):="111111111";
                     do : out std_logic_vector(8 downto 0);
                     wa : in std_logic_vector(10 downto 0):="11111111111";
                     we : in std_logic:='0';
                   nclk : in std_logic;
                    clk : in std_logic);
    end iff1;
--
architecture low_level_definition of iff1 is
--
-- Attributes to define ROM contents during implementation synthesis. 
-- The information is repeated in the generic map for functional simulation
--
attribute INIT_00 : string; 
attribute INIT_01 : string; 
attribute INIT_02 : string; 
attribute INIT_03 : string; 
attribute INIT_04 : string; 
attribute INIT_05 : string; 
attribute INIT_06 : string; 
attribute INIT_07 : string; 
attribute INIT_08 : string; 
attribute INIT_09 : string; 
attribute INIT_0A : string; 
attribute INIT_0B : string; 
attribute INIT_0C : string; 
attribute INIT_0D : string; 
attribute INIT_0E : string; 
attribute INIT_0F : string; 
attribute INIT_10 : string; 
attribute INIT_11 : string; 
attribute INIT_12 : string; 
attribute INIT_13 : string; 
attribute INIT_14 : string; 
attribute INIT_15 : string; 
attribute INIT_16 : string; 
attribute INIT_17 : string; 
attribute INIT_18 : string; 
attribute INIT_19 : string; 
attribute INIT_1A : string; 
attribute INIT_1B : string; 
attribute INIT_1C : string; 
attribute INIT_1D : string; 
attribute INIT_1E : string; 
attribute INIT_1F : string; 
attribute INIT_20 : string; 
attribute INIT_21 : string; 
attribute INIT_22 : string; 
attribute INIT_23 : string; 
attribute INIT_24 : string; 
attribute INIT_25 : string; 
attribute INIT_26 : string; 
attribute INIT_27 : string; 
attribute INIT_28 : string; 
attribute INIT_29 : string; 
attribute INIT_2A : string; 
attribute INIT_2B : string; 
attribute INIT_2C : string; 
attribute INIT_2D : string; 
attribute INIT_2E : string; 
attribute INIT_2F : string; 
attribute INIT_30 : string; 
attribute INIT_31 : string; 
attribute INIT_32 : string; 
attribute INIT_33 : string; 
attribute INIT_34 : string; 
attribute INIT_35 : string; 
attribute INIT_36 : string; 
attribute INIT_37 : string; 
attribute INIT_38 : string; 
attribute INIT_39 : string; 
attribute INIT_3A : string; 
attribute INIT_3B : string; 
attribute INIT_3C : string; 
attribute INIT_3D : string; 
attribute INIT_3E : string; 
attribute INIT_3F : string; 
attribute INITP_00 : string;
attribute INITP_01 : string;
attribute INITP_02 : string;
attribute INITP_03 : string;
attribute INITP_04 : string;
attribute INITP_05 : string;
attribute INITP_06 : string;
attribute INITP_07 : string;
attribute xc_props : STRING;
--
-- Attributes to define ROM contents during implementation synthesis.
--
attribute INIT_00 of ram_1024_x_18 : label is  "01802005131312121111101000F1008054019E0154039D011FE81D803E051EF0";
attribute INIT_01 of ram_1024_x_18 : label is  "079806900588248004BB62986290624802406A90698868800A04090881010808";
attribute INIT_02 of ram_1024_x_18 : label is  "9208930E90089108920893088B0E67986690658864808B009300920091009006";
attribute INIT_03 of ram_1024_x_18 : label is  "540E8001541081022808C10129082A04541BC201733872307128702090089108";
attribute INIT_04 of ram_1024_x_18 : label is  "544D3F021F023F051F0F3F813F801F403F041F033F051F001F125F349F567F78";
attribute INIT_05 of ram_1024_x_18 : label is  "3F021F03404D3F021F01545E3FF861BB545E3FF862703F021F0150503F021F02";
attribute INIT_06 of ram_1024_x_18 : label is  "0D320E540F76089809BA0ADC0BFE04EF05CD06AB07890067014502230301404D";
attribute INIT_07 of ram_1024_x_18 : label is  "16303F707FFF1F3057F8375817383F787FFF1F381D1410C311D212E113F00C10";
attribute INIT_08 of ram_1024_x_18 : label is  "B679979954F8344014203F607FFF1F2055F8354815283F687FFF1F2856F83650";
attribute INIT_09 of ram_1024_x_18 : label is  "14207568754815287670765016307778775817381D145476DD0160E6B45AB582";
attribute INIT_0A of ram_1024_x_18 : label is  "1F5857F83F781F38375817381D145496DD0160E6B46EB5D9B6EB97A174607440";
attribute INIT_0B of ram_1024_x_18 : label is  "1F4855F83F681F283548152856F83F701F5056F83F701F303650163057F83F78";
attribute INIT_0C of ram_1024_x_18 : label is  "DD0160E6B48FB51BB6BC97DC54F83F601F4054F83F601F203440142055F83F68";
attribute INIT_0D of ram_1024_x_18 : label is  "B6C197D67460744014207568754815287670765016307778775817381D1454AA";
attribute INIT_0E of ram_1024_x_18 : label is  "0E500F581060116812701378B480B588B6909798400054D2DD0160E6B4CAB562";
attribute INIT_0F of ram_1024_x_18 : label is  "0718082009280A300B3854F3DE0187088608850884088702870C1E020C400D48";
attribute INIT_10 of ram_1024_x_18 : label is  "1783A0A0A1A8A2B083B85504DE01A30080008100820083061E05040005080610";
attribute INIT_11 of ram_1024_x_18 : label is  "1FA374F81F8875F81F8976F81F8A77F81F8BA0A0A1A8A2B083B8148015811682";
attribute INIT_12 of ram_1024_x_18 : label is  "970674F81FB475F81FB576F81FB677F81FB774F81FA075F81FA176F81FA277F8";
attribute INIT_13 of ram_1024_x_18 : label is  "400034BC35BD36BE37BF5535DEBB3FF0DE041FF09EC01EC4B700940095009600";
attribute INIT_14 of ram_1024_x_18 : label is  "5548DE0177315D4E970677805D4B9F0C1E083FE862949DC81DF81700629E1F33";
attribute INIT_15 of ram_1024_x_18 : label is  "9DD01DF86295617C1FD36295617C1FD21720160262951F0F629D40005544DDC7";
attribute INIT_16 of ram_1024_x_18 : label is  "17FE160162951FAA629D417C7FFF6294617C7FFF6294555FDDCF6295617C1FE8";
attribute INIT_17 of ram_1024_x_18 : label is  "76805D809F0C1E087FFF6294617C7FFF62945571DDDF617C3FE862949DE01DF5";
attribute INIT_18 of ram_1024_x_18 : label is  "6295617C1FD517DE160362951FA5629D4000557DDE01770576805D8596009706";
attribute INIT_19 of ram_1024_x_18 : label is  "36D137D0617C7FFF6294617C7FFF62945594DD01617C62941D216295617C1FD6";
attribute INIT_1A of ram_1024_x_18 : label is  "7FFF629455A8DD933FE8617C62949D941DEC55A3DD0162D11BFA1D0817001600";
attribute INIT_1B of ram_1024_x_18 : label is  "1F093F801F086252614040003F9762943F96629436953794617C7FFF6294617C";
attribute INIT_1C of ram_1024_x_18 : label is  "3FA83F3F1FC03FB31F0F3FB21F0E3FB11F0D3FB01F0C3F831F0B3F821F0A3F81";
attribute INIT_1D of ram_1024_x_18 : label is  "1F8060613FAF1FC73FAE1FC63FAD1FC53FAC1FC43FAB1FC33FAA1FC23FA91FC1";
attribute INIT_1E of ram_1024_x_18 : label is  "DDCF55F37FF01FE89DD01EC81DF855E4DDCF3FE81F039DD01DF83FD31F003FD2";
attribute INIT_1F of ram_1024_x_18 : label is  "1FC03FA81F402CB32DB22EB12FB030833182328133806252615340001FFF55EB";
attribute INIT_20 of ram_1024_x_18 : label is  "1FCD3FB41FCC3FAF1FC63FAE1FC53FAD1FC43FAC1FC33FAB1FC23FAA1FC13FA9";
attribute INIT_21 of ram_1024_x_18 : label is  "7F181F9057F87F101F9157F87F081F9217F87F001F93618860613FB61FCE3FB5";
attribute INIT_22 of ram_1024_x_18 : label is  "57F87F401F8B57F87F381F8C57F87F301F8D57F87F281F8E57F87F201F8F57F8";
attribute INIT_23 of ram_1024_x_18 : label is  "1F8557F87F681F8657F87F601F8757F87F581F8857F87F501F8957F87F481F8A";
attribute INIT_24 of ram_1024_x_18 : label is  "7F981F8057F87F901F8157F87F881F8257F87F801F8357F87F781F8457F87F70";
attribute INIT_25 of ram_1024_x_18 : label is  "3FB63FB53FB43FA73FA63FA53FA41FFF5654DEBF3FF09EC01EC01F0040005FB8";
attribute INIT_26 of ram_1024_x_18 : label is  "428162816281628162816281628162811FFF40003FBF1FB83FBE1F013FB71F80";
attribute INIT_27 of ram_1024_x_18 : label is  "1FB862681F3C62D056783BD837F81F02C0011BF0170162D11B0F62C762D062CF";
attribute INIT_28 of ram_1024_x_18 : label is  "62D662CC42D11B2D9F08940C140262D11B0E62C762CA62CC5E8E9F029F0C4000";
attribute INIT_29 of ram_1024_x_18 : label is  "1B3062D61FCC42B062B062B062B062B062B062B062B01FFF42C79F0E62D11B3C";
attribute INIT_2A of ram_1024_x_18 : label is  "40001FB8629562D11B1856A73BD837B01602C0011B18170162D11B0262C762D1";
attribute INIT_2B of ram_1024_x_18 : label is  "9F08940C140262CD62C752B93BD862D656B63BD8C0011B0162CC5EC29F029F0C";
attribute INIT_2C of ram_1024_x_18 : label is  "62D642D11B0162C742CD62D64000350215019F0E62D11B0662D662CC42D11B04";
attribute INIT_2D of ram_1024_x_18 : label is  "00000000000000000000C001DB014000350215004000C00056D23BD8C0011BF0";
attribute INIT_2E of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_2F of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_30 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_31 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_32 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_33 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_34 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_35 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_36 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_37 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_38 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_39 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3A of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3B of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3C of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3D of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3E of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3F of ram_1024_x_18 : label is  "42D9000000000000000000000000000000000000000000000000000000000000";
attribute INITP_00 of ram_1024_x_18 : label is "51551000000000038E37DE32CA288800CCCEC55AAAA956AA551555B32AA2CCC8";
attribute INITP_01 of ram_1024_x_18 : label is "5572AA8555555B30055555533005555555555555555330055555533005515515";
attribute INITP_02 of ram_1024_x_18 : label is "383CF3F00CF3CF3F0FBE0CECC38E3C0CAAB3302A999999999999956A9570AA15";
attribute INITP_03 of ram_1024_x_18 : label is "A2AAABE3372338223AAAAAAA8AAAAAAAABEBBACF3CFC3300ACF3CF3EF833B03A";
attribute INITP_04 of ram_1024_x_18 : label is "73D6C33FFFFF2888AAA8CC0965965965965965965965965965965BEAAAAAAAAA";
attribute INITP_05 of ram_1024_x_18 : label is "000000000000000000228BDCF3FA2CFCABF7DCFA9F35B0CF33FFFCECFCAB3FEA";
attribute INITP_06 of ram_1024_x_18 : label is "0000000000000000000000000000000000000000000000000000000000000000";
attribute INITP_07 of ram_1024_x_18 : label is "C000000000000000000000000000000000000000000000000000000000000000";
attribute xc_props of ram_1024_x_18 : label is "WRITE_MODE_A=READ_FIRST,WRITE_MODE_B=READ_FIRST";
--
begin
--
  --Instantiate the Xilinx primitive for a block RAM
  ram_1024_x_18: RAMB16_S9_S18
  --synthesis translate_off
  --translate_off
  --INIT values repeated to define contents for functional simulation
  generic map (INIT_00 => X"01802005131312121111101000F1008054019E0154039D011FE81D803E051EF0",
               INIT_01 => X"079806900588248004BB62986290624802406A90698868800A04090881010808",
               INIT_02 => X"9208930E90089108920893088B0E67986690658864808B009300920091009006",
               INIT_03 => X"540E8001541081022808C10129082A04541BC201733872307128702090089108",
               INIT_04 => X"544D3F021F023F051F0F3F813F801F403F041F033F051F001F125F349F567F78",
               INIT_05 => X"3F021F03404D3F021F01545E3FF861BB545E3FF862703F021F0150503F021F02",
               INIT_06 => X"0D320E540F76089809BA0ADC0BFE04EF05CD06AB07890067014502230301404D",
               INIT_07 => X"16303F707FFF1F3057F8375817383F787FFF1F381D1410C311D212E113F00C10",
               INIT_08 => X"B679979954F8344014203F607FFF1F2055F8354815283F687FFF1F2856F83650",
               INIT_09 => X"14207568754815287670765016307778775817381D145476DD0160E6B45AB582",
               INIT_0A => X"1F5857F83F781F38375817381D145496DD0160E6B46EB5D9B6EB97A174607440",
               INIT_0B => X"1F4855F83F681F283548152856F83F701F5056F83F701F303650163057F83F78",
               INIT_0C => X"DD0160E6B48FB51BB6BC97DC54F83F601F4054F83F601F203440142055F83F68",
               INIT_0D => X"B6C197D67460744014207568754815287670765016307778775817381D1454AA",
               INIT_0E => X"0E500F581060116812701378B480B588B6909798400054D2DD0160E6B4CAB562",
               INIT_0F => X"0718082009280A300B3854F3DE0187088608850884088702870C1E020C400D48",
               INIT_10 => X"1783A0A0A1A8A2B083B85504DE01A30080008100820083061E05040005080610",
               INIT_11 => X"1FA374F81F8875F81F8976F81F8A77F81F8BA0A0A1A8A2B083B8148015811682",
               INIT_12 => X"970674F81FB475F81FB576F81FB677F81FB774F81FA075F81FA176F81FA277F8",
               INIT_13 => X"400034BC35BD36BE37BF5535DEBB3FF0DE041FF09EC01EC4B700940095009600",
               INIT_14 => X"5548DE0177315D4E970677805D4B9F0C1E083FE862949DC81DF81700629E1F33",
               INIT_15 => X"9DD01DF86295617C1FD36295617C1FD21720160262951F0F629D40005544DDC7",
               INIT_16 => X"17FE160162951FAA629D417C7FFF6294617C7FFF6294555FDDCF6295617C1FE8",
               INIT_17 => X"76805D809F0C1E087FFF6294617C7FFF62945571DDDF617C3FE862949DE01DF5",
               INIT_18 => X"6295617C1FD517DE160362951FA5629D4000557DDE01770576805D8596009706",
               INIT_19 => X"36D137D0617C7FFF6294617C7FFF62945594DD01617C62941D216295617C1FD6",
               INIT_1A => X"7FFF629455A8DD933FE8617C62949D941DEC55A3DD0162D11BFA1D0817001600",
               INIT_1B => X"1F093F801F086252614040003F9762943F96629436953794617C7FFF6294617C",
               INIT_1C => X"3FA83F3F1FC03FB31F0F3FB21F0E3FB11F0D3FB01F0C3F831F0B3F821F0A3F81",
               INIT_1D => X"1F8060613FAF1FC73FAE1FC63FAD1FC53FAC1FC43FAB1FC33FAA1FC23FA91FC1",
               INIT_1E => X"DDCF55F37FF01FE89DD01EC81DF855E4DDCF3FE81F039DD01DF83FD31F003FD2",
               INIT_1F => X"1FC03FA81F402CB32DB22EB12FB030833182328133806252615340001FFF55EB",
               INIT_20 => X"1FCD3FB41FCC3FAF1FC63FAE1FC53FAD1FC43FAC1FC33FAB1FC23FAA1FC13FA9",
               INIT_21 => X"7F181F9057F87F101F9157F87F081F9217F87F001F93618860613FB61FCE3FB5",
               INIT_22 => X"57F87F401F8B57F87F381F8C57F87F301F8D57F87F281F8E57F87F201F8F57F8",
               INIT_23 => X"1F8557F87F681F8657F87F601F8757F87F581F8857F87F501F8957F87F481F8A",
               INIT_24 => X"7F981F8057F87F901F8157F87F881F8257F87F801F8357F87F781F8457F87F70",
               INIT_25 => X"3FB63FB53FB43FA73FA63FA53FA41FFF5654DEBF3FF09EC01EC01F0040005FB8",
               INIT_26 => X"428162816281628162816281628162811FFF40003FBF1FB83FBE1F013FB71F80",
               INIT_27 => X"1FB862681F3C62D056783BD837F81F02C0011BF0170162D11B0F62C762D062CF",
               INIT_28 => X"62D662CC42D11B2D9F08940C140262D11B0E62C762CA62CC5E8E9F029F0C4000",
               INIT_29 => X"1B3062D61FCC42B062B062B062B062B062B062B062B01FFF42C79F0E62D11B3C",
               INIT_2A => X"40001FB8629562D11B1856A73BD837B01602C0011B18170162D11B0262C762D1",
               INIT_2B => X"9F08940C140262CD62C752B93BD862D656B63BD8C0011B0162CC5EC29F029F0C",
               INIT_2C => X"62D642D11B0162C742CD62D64000350215019F0E62D11B0662D662CC42D11B04",
               INIT_2D => X"00000000000000000000C001DB014000350215004000C00056D23BD8C0011BF0",
               INIT_2E => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_2F => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_30 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_31 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_32 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_33 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_34 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_35 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_36 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_37 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_38 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_39 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3A => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3B => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3C => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3D => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3E => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3F => X"42D9000000000000000000000000000000000000000000000000000000000000",    
               INITP_00 => X"51551000000000038E37DE32CA288800CCCEC55AAAA956AA551555B32AA2CCC8",
               INITP_01 => X"5572AA8555555B30055555533005555555555555555330055555533005515515",
               INITP_02 => X"383CF3F00CF3CF3F0FBE0CECC38E3C0CAAB3302A999999999999956A9570AA15",
               INITP_03 => X"A2AAABE3372338223AAAAAAA8AAAAAAAABEBBACF3CFC3300ACF3CF3EF833B03A",
               INITP_04 => X"73D6C33FFFFF2888AAA8CC0965965965965965965965965965965BEAAAAAAAAA",
               INITP_05 => X"000000000000000000228BDCF3FA2CFCABF7DCFA9F35B0CF33FFFCECFCAB3FEA",
               INITP_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INITP_07 => X"C000000000000000000000000000000000000000000000000000000000000000",
               WRITE_MODE_A => "READ_FIRST",
               WRITE_MODE_B => "READ_FIRST")
  --translate_on
  --synthesis translate_on
-- synthesis translate_on
  port map(   DIA => di(7 downto 0),
             DIPA => di(8 downto 8),
              ENA => '1',
              WEA => we,
             SSRA => '0',
             CLKA => nclk,
            ADDRA => wa,
              DOA => do(7 downto 0),
             DOPA => do(8 downto 8),
              DIB => "1111111111111111",
             DIPB => "11",
              ENB => '1',
              WEB => '0',
             SSRB => '0',
             CLKB => clk,
            ADDRB => address,
              DOB => instruction(15 downto 0),
             DOPB => instruction(17 downto 16)); 
--
end low_level_definition;
--
------------------------------------------------------------------------------------
--
-- END OF FILE iff1.vhd
--
------------------------------------------------------------------------------------
