--
-- Definition of a single port ROM for KCPSM-II program defined by iff1.psm
-- and assmbled using KCPSM2 assembler.
--
--CB Modified to allow the KCPSM-II to read and write the program space
--
-- Standard IEEE libraries
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--
-- The Unisim Library is used to define Xilinx primitives. It is also used during
-- simulation. The source can be viewed at %XILINX%\vhdl\src\unisims\unisim_VCOMP.vhd
--  
library unisim;
use unisim.vcomponents.all;
--
--
entity iff1 is
    Port (      address : in std_logic_vector(9 downto 0);
            instruction : out std_logic_vector(17 downto 0);
                     di : in std_logic_vector(8 downto 0):="111111111";
                     do : out std_logic_vector(8 downto 0);
                     wa : in std_logic_vector(10 downto 0):="11111111111";
                     we : in std_logic:='0';
                   nclk : in std_logic;
                    clk : in std_logic);
    end iff1;
--
architecture low_level_definition of iff1 is
begin
--
  --Instantiate the Xilinx primitive for a block RAM
  ram_1024_x_18: RAMB16_S9_S18
  port map(   DIA => di(7 downto 0),
             DIPA => di(8 downto 8),
              ENA => '1',
              WEA => we,
             SSRA => '0',
             CLKA => nclk,
            ADDRA => wa,
              DOA => do(7 downto 0),
             DOPA => do(8 downto 8),
              DIB => "1111111111111111",
             DIPB => "11",
              ENB => '1',
              WEB => '0',
             SSRB => '0',
             CLKB => clk,
            ADDRB => address,
              DOB => instruction(15 downto 0),
             DOPB => instruction(17 downto 16)); 
--
end low_level_definition;
--
------------------------------------------------------------------------------------
--
-- END OF FILE iff1.vhd
--
------------------------------------------------------------------------------------

