--******************************************************************************
--
--  Xilinx, Inc. 2004                 www.xilinx.com
--
--  FPGA Bitstream Copy Protection Reference Design Using the
--  Maxim DS2432 Secure Serial EEPROM - Check DS2432 Version
--
--*******************************************************************************
--
--  File name :       IFFTEST_TB.VHD
--
--  Description :     This is the version of the bitstream copy protection
--                    reference design that checks for a valid DS2432
--
--  Date - revision : 04/15/2004
--
--  Author :          Catalin Baetoniu
--
--  Contact :         catalinb@xilinx.com - This design is not supported by the hotline
--
--  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are 
--              provided to you "as is". Xilinx and its licensors make and you 
--              receive no warranties or conditions, express, implied, 
--              statutory or otherwise, and Xilinx specifically disclaims any 
--              implied warranties of merchantability, non-infringement, or 
--              fitness for a particular purpose. Xilinx does not warrant that 
--              the functions contained in these designs will meet your 
--              requirements, or that the operation of these designs will be 
--              uninterrupted or error free, or that defects in the Designs 
--              will be corrected. Furthermore, Xilinx does not warrant or 
--              make any representations regarding use or the results of the 
--              use of the designs in terms of correctness, accuracy, 
--              reliability, or otherwise. 
--
--              LIMITATION OF LIABILITY. In no event will Xilinx or its 
--              licensors be liable for any loss of data, lost profits, cost 
--              or procurement of substitute goods or services, or for any 
--              special, incidental, consequential, or indirect damages 
--              arising from the use or operation of the designs or 
--              accompanying documentation, however caused and on any theory 
--              of liability. This limitation will apply even if Xilinx 
--              has been advised of the possibility of such damage. This 
--              limitation shall apply not-withstanding the failure of the 
--              essential purpose of any limited remedies herein. 
--
--  Copyright  2004 Xilinx, Inc.
--  All rights reserved 
-- 
--*****************************************************************************

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;

entity IFFTEST_TB is
end IFFTEST_TB;

architecture TB of IFFTEST_TB is
  component IFFTEST 
  port(clkin:in STD_LOGIC;
       RESETn:in STD_LOGIC;
       INIT:out STD_LOGIC;		   --	green LED, active high
       GREEN_LED:out STD_LOGIC;	--	green LED, active high
       YELLOW_LED:out STD_LOGIC; --	yellown LED, active high
       RED_LED:out STD_LOGIC;    --	red LED, active high
       IB:inout STD_LOGIC);
  end component;

  signal clkin:STD_LOGIC:='1';
  signal RESETn:STD_LOGIC:='0';
  signal INIT:STD_LOGIC;		   --	green LED, active high
  signal GREEN_LED:STD_LOGIC;	--	green LED, active high
  signal YELLOW_LED:STD_LOGIC; --	yellown LED, active high
  signal RED_LED:STD_LOGIC;    --	red LED, active high
  signal IB:STD_LOGIC:='Z';
begin
  clkin<=not clkin after 5.0 ns;
  RESETn<='1' after 25.0 ns;

  uut:IFFTEST port map(clkin=>clkin,
                       RESETn=>RESETn,
                       INIT=>INIT,
                       GREEN_LED=>GREEN_LED,
                       YELLOW_LED=>YELLOW_LED,
                       RED_LED=>RED_LED,
                       IB=>IB);
end TB;