// Shalin Sheth
// Xilinx
// XAPP780 - FPGA Copy Protection 
// Date: April 18, 2005

#include <stdio.h>
#include <ctype.h>


void intro(void)
{
  printf("\nXAPP780 - FPGA Copy Protection\r\n");
  printf("Shalin Sheth, Xilinx - Version 1.0\nBuild date %s\r\n",__DATE__);
  printf("\nxapp780 <input file> <Scramble Key>\r\n");
  printf("\nExample:\n");  printf("xapp780 in_file 01234567\n\n\n");
}


void header(void)
{
  printf("\nXAPP780 - FPGA Copy Protection\r\n");
  printf("Shalin Sheth, Xilinx - Version 1.0\nBuild date %s\r\n",__DATE__);

}


char hex2char(int a)
{
if (a==0) return '0';
if (a==1) return '1';
if (a==2) return '2';
if (a==3) return '3';
if (a==4) return '4';
if (a==5) return '5';
if (a==6) return '6';
if (a==7) return '7';
if (a==8) return '8';
if (a==9) return '9';
if (a==10) return 'A';
if (a==11) return 'B';
if (a==12) return 'C';
if (a==13) return 'D';
if (a==14) return 'E';
if (a==15) return 'F';
return '!';
}


int char2int(char a)
{
if (a=='0') return 0;
if (a=='1') return 1;
if (a=='2') return 2;
if (a=='3') return 3;
if (a=='4') return 4;
if (a=='5') return 5;
if (a=='6') return 6;
if (a=='7') return 7;
if (a=='8') return 8;
if (a=='9') return 9;
if (a=='A' || a=='a') return 10;
if (a=='B' || a=='b') return 11;
if (a=='C' || a=='c') return 12;
if (a=='D' || a=='d') return 13;
if (a=='E' || a=='e') return 14;
if (a=='F' || a=='f') return 15;
return '!';

}

int isHEX(char a)
{
if (a=='0') return 1;
if (a=='1') return 1;
if (a=='2') return 1;
if (a=='3') return 1;
if (a=='4') return 1;
if (a=='5') return 1;
if (a=='6') return 1;
if (a=='7') return 1;
if (a=='8') return 1;
if (a=='9') return 1;
if (a=='A' || a=='a') return 1;
if (a=='B' || a=='b') return 1;
if (a=='C' || a=='c') return 1;
if (a=='D' || a=='d') return 1;
if (a=='E' || a=='e') return 1;
if (a=='F' || a=='f') return 1;
return 0;

}

char bitswap(char a)
{
if (a=='0') return '0';
if (a=='1') return '8';
if (a=='2') return '4';
if (a=='3') return 'C';
if (a=='4') return '2';
if (a=='5') return 'A';
if (a=='6') return '6';
if (a=='7') return 'E';
if (a=='8') return '1';
if (a=='9') return '9';
if (a=='A' || a=='a') return '5';
if (a=='B' || a=='b') return 'D';
if (a=='C' || a=='c') return '3';
if (a=='D' || a=='d') return 'B';
if (a=='E' || a=='e') return '7';
if (a=='F' || a=='f') return 'F';
return '!';
}

/////////////////////////////////////////////////

/////////////////////////////////////////////////

int sign(char * in_hex)
{

	//Program files setup and check.
	char* input_mem;
	char* tmp_string;
	char* output_mcs;
	char* sync_word;
	unsigned int ret_error;
	unsigned int q, i;
	FILE * in;
	FILE * output_mem;
	FILE * DataOut;

	unsigned long int intKey;
	unsigned int K, n;
	unsigned char get_char [1024][6];
	unsigned int  code [1024];
	unsigned int  byte_code [1024*2];
	unsigned char * key;
	unsigned char Count;
	unsigned short INIT_VAL [9], LAST_VAL [9];
	unsigned int SRL16[16];
	unsigned int D, Q, Q15;



DataOut = fopen("include.vhd","w");

in = fopen(in_hex,"r");


//Program files setup and check

// if the number of inputs areguments are not 4 or 5 then 
// output the proper format for command line usage and
// output a Invalid Command Error and exit the program.


for(K=0; K<1024*2; K++)
	{
byte_code[K] = 0;
	}

for(K=0; K<1024; K++)
	{
//	printf("%i = ", K);
	code[K]=0;
	for(i=0; i<6; i++)
		{
		get_char[K][i] = fgetc(in);
//		printf("%c", get_char[K][i]);
		if(i!=5)
			code[K] = (code[K] ) + (char2int(get_char[K][i]) << (4*(4-i)));
		}
	byte_code[2*K]=code[K]&0xFF;
	byte_code[2*K+1]=(code[K]>>8)&0xFF;
  switch((code[K]>>16) & 0x3)
     	{
        case 1:	byte_code[2*K]=byte_code[2*K]+256; break;
        case 2:	byte_code[2*K+1]=byte_code[2*K+1]+256; break;
        case 3:	byte_code[2*K+1]=byte_code[2*K+1]+256;
			byte_code[2*K]=byte_code[2*K]+256; break;
//        default : byte_code[2*K+1]=byte_code[2*K+1]+256;
//			byte_code[2*K]=byte_code[2*K]; break;
     	}
//printf(" k = %d, code[%d] = %x, byte_code[%d]=%x, byte_code[%d]=%x\n", K, K, code[K], 2*K, byte_code[2*K], 2*K+1, byte_code[2*K+1]);
	}


for(K=0; K<1024*2; K++)
	{
//	printf("K = %d, byte_code = %x\n", K, byte_code[K]);
	}
for(q=0;q<9;q++)
	{
	srand(time(NULL) ^ gmtime(NULL));
	INIT_VAL[q]=rand() & 0xFFFF;
//	printf("INIT_VAL[%d] = %x\n", q, INIT_VAL[q]);
	}

/*for(i=0;i<2048;i++)
    {
      code[i]=i % 512;
//	printf("code[%d] = %x\n", i, code[i]);
    }*/

/*INIT_VAL[8]=0x1234;
INIT_VAL[7]=0x5678;
INIT_VAL[6]=0x9012;
INIT_VAL[5]=0x3456;
INIT_VAL[4]=0x7890;
INIT_VAL[3]=0x1234;
INIT_VAL[2]=0x5678;
INIT_VAL[1]=0x9012;
INIT_VAL[0]=0x3456;*/

/*INIT_VAL[8]=0x5AC9;
INIT_VAL[7]=0xBCE7;
INIT_VAL[6]=0x416F;
INIT_VAL[5]=0x86CA;
INIT_VAL[4]=0x0626;
INIT_VAL[3]=0x5E3F;
INIT_VAL[2]=0xD6CF;
INIT_VAL[1]=0x7A75;
INIT_VAL[0]=0xD37D;*/


for(q=0;q<16;q++)
	SRL16[q] = 0x0;

for(q=0;q<9;q++)
	LAST_VAL[q] = 0x0;

for(i=0;i<9;i++)
	{
//	printf("INIT_VAL[%d] = %x\n", i, INIT_VAL[i]);
      for(q=0;q<16;q++)
		{
      	if (((INIT_VAL[i] >> q)%2)>0)
		{ 
//		printf("INIT_VAL[%d] = %d, SRL16[%d] = %x", i, (INIT_VAL[i] >> q), q, SRL16[q]);
		SRL16[q] = (SRL16[q] +(1 << i)) & 0x1FF;
//		printf(" new SRL16[%d] = %x\n", q, SRL16[q]);		
		}
//		else
//			printf("INIT_VAL[%d] = %d, q = %d\n", i, (INIT_VAL[i] >> q), q);

		}
	}
Q=0;
Q15=0;

for(K=0;K<2048;K++)
    {
      D= (byte_code[K] ^ (Q15 >> 1) ^ (((Q15 << 1) & 0x1FF) | (Q15 & 1)) ^ Q) & 0x1FF;
      Q=0;
      for(i=0;i<9;i++)
          Q = (Q + (SRL16[((Q15 << i) + ((Q15 >> (9-i))) & 0xF)] & (1 << i))) & 0x1FF;
      Q15=SRL16[15];
//     printf("K=%d byte[K]=%x D=%x Q=%x Q15=%x\n", K,byte_code[K],D,Q,Q15);
      for(n=15;n>0;n--)
        SRL16[n]=SRL16[n-1];
      SRL16[0]=D;
    }

//for(i=0;i<16;i++)
//	printf("SRL16[%d] = %x\n", i, SRL16[i]);

//printf("\n W = (9*q+i) / 16, T = (9*q+i) mod 16\n");
//printf("LAST_VAL[W] = LAST_VAL[W] + (SRL16[15-q] >> i & 1 << (T))\n");
//printf("PASCAL: Inc(LAST_VAL[(9*N+I) div 16],SRL16[15-N] shr I and 1 shl ((9*N+I) mod 16))\n");


for(i=0;i<9;i++)
      for(q=0;q<16;q++)
		{
//		printf("i=%d, q=%d, W=%d, T=%d, SRL16[15-%x]=%x, LAST_VAL[W]=%x, ", i, q, (9*q+i) / 16, ((9*q+i) % 16), q, SRL16[15-q], LAST_VAL[(9*q+i) / 16]);
		LAST_VAL[(9*q+i) / 16] = LAST_VAL[(9*q+i) / 16] +
			((((SRL16[15-q] >> i) & 1) << ((9*q+i) % 16)));
//		printf("new LAST_VAL[W] = %x \n", LAST_VAL[(9*q+i) / 16]); 
//		printf("SRL16[15-q] >>i = %x & 1 << T = %x\n", (SRL16[15-q] >> i),  1 << ((9*q+i) % 16));

		}
  
//printf("Initial State \n\r");
//for(i=9;i>0;i--) 
// printf("%c",hex2char((INIT_VAL[i-1]>>n) && 0xF));
//printf(" %x ",INIT_VAL[i-1]);

//printf("\n\rLast State \n\r");
//for(i=9;i>0;i--) 
// printf("%c",hex2char((LAST_VAL[i-1]>>n) && 0xF));
//printf(" %x ",LAST_VAL[i-1]);

fprintf(DataOut,"  constant INIT_VAL:UNSIGNED(143 downto 0):=X");
fputc('"',DataOut);
  for(i=9;i>0;i--)  
	{
	fprintf(DataOut, "%c", hex2char((INIT_VAL[i-1]>>12)%16)); // print address bit 4
	fprintf(DataOut, "%c", hex2char((INIT_VAL[i-1]>>8)%16)); // print address bit 3
	fprintf(DataOut, "%c", hex2char((INIT_VAL[i-1]>>4)%16)); // print address bit 2
	fprintf(DataOut, "%c", hex2char((INIT_VAL[i-1])%16)); // print address bit 1
	}
fputc('"',DataOut);
  fprintf(DataOut,";   -- Initial State\n");

fprintf(DataOut,"  constant LAST_VAL:UNSIGNED(143 downto 0):=X");
fputc('"',DataOut);
  for(i=9;i>0;i--)  
	{
	fprintf(DataOut, "%c", hex2char((LAST_VAL[i-1]>>12)%16)); // print address bit 4
	fprintf(DataOut, "%c", hex2char((LAST_VAL[i-1]>>8)%16)); // print address bit 3
	fprintf(DataOut, "%c", hex2char((LAST_VAL[i-1]>>4)%16)); // print address bit 2
	fprintf(DataOut, "%c", hex2char((LAST_VAL[i-1])%16)); // print address bit 1
	}
fputc('"',DataOut);
  fprintf(DataOut,";   -- Final State");

fclose(in);
fclose(DataOut);

	
	return 0;	

}

/////////////////////////////////////////////////////////////////////////////

int main(int argc, char * argv[])
{

	//Program files setup and check.
	char* input_mem;
	char* out_mem;
	char* out_hex;
	char* tmp_string;
	char* output_mcs;
	char* sync_word;
	unsigned int ret_error;
	unsigned int q, i;
	FILE * in;
	FILE * output_hex;
	FILE * output_mem;

	unsigned long int intKey;
	unsigned int K;
	unsigned char get_char [1024][6];
	unsigned int  code [1024];
	unsigned char * key;
	unsigned char Count;





//Program files setup and check

// if the number of inputs areguments are not 4 or 5 then 
// output the proper format for command line usage and
// output a Invalid Command Error and exit the program.
if (argc !=3 )
	{
	intro();
	printf("ERROR: Invalid Command\n\r");
	return 0;
	}
	// output header to display program information.
	else header();


input_mem = argv[1]; // copy name of input MEM file.
strcat(input_mem, ".hex");

key = argv[2]; // sync word

//strcpy(out_hex, "iff_scr_v30.hex");
//strcpy(out_mem, "iff_scr_v30.mem");
out_hex = "iff_scr_v30.hex";
out_mem = "iff_scr_v30.mem";

output_hex = fopen(out_hex,"w");
output_mem = fopen(out_mem,"w");

//check to see if input MEM file is valid.
if((in=fopen(input_mem,"r"))==NULL)
	{
	printf("\n\rFile output error - cannot open %s",input_mem);
	ret_error=1;
	}

if(!(isHEX(key[0]) && isHEX(key[1]) && isHEX(key[2]) && isHEX(key[3]) && 
isHEX(key[4]) && isHEX(key[5]) && isHEX(key[6]) && isHEX(key[7])) )
	{
	printf("\n\rInvalid Scramble Key %s\n\n\r",key);

	  printf("\nCommand syntax: xapp780 <input file> <Scramble Key>\r\n");
	  printf("\nExample: ");  printf("xapp780 in_file 01234567\n\n\n");
	ret_error=1;
	}

// Exit program if either input files are invalid.
if(ret_error)
	return 1;
	else 
		{
		printf("\n\rInput Hex File: %s", input_mem);
		printf("\n\rOutput Hex File: %s", out_hex);
		printf("\n\rOutput Mem File: %s", out_mem);
		printf("\n\rOutput VHDL Signature file: include.vhd");
		printf("\n\rScramble Key: %s\n\n", key);
		}

for(K=0; K<1024; K++)
	{
	code[K] = 0x0;
	}


for(K=0; K<1024; K++)
	{
	//fprintf(output_hex, "%i = ", K);
	for(i=0; i<6; i++)
		{
		get_char[K][i] = fgetc(in);
		//fprintf(output_hex, "%c", get_char[K][i]);
		if(i!=5)
			code[K] = (code[K] ) + (char2int(get_char[K][i]) << (4*(4-i)));
		}
	//fprintf(output_hex, " %x\n\r", code[K]);
	}

intKey=0;

for(i=0; i<8; i++)
	{
	intKey = (intKey ) + (char2int(key[7-i]) << (4*(i)));
	}

//printf("Scramble Key: %s\n\n", key);
//printf("Scramble Key: %x\n\n", intKey);

fprintf(output_mem, "@0\n"); 


for(K=0; K<64; K++)
	{
	//fprintf(output_hex, "%0x ", code[K]);
	//fprintf(output_hex, "%0x \n", code[K]);
	fprintf(output_hex, "%c", hex2char((code[K]>>16)%16)); // print address bit 5
	fprintf(output_hex, "%c", hex2char((code[K]>>12)%16)); // print address bit 4
	fprintf(output_hex, "%c", hex2char((code[K]>>8)%16)); // print address bit 3
	fprintf(output_hex, "%c", hex2char((code[K]>>4)%16)); // print address bit 2
	fprintf(output_hex, "%c\n", hex2char((code[K])%16)); // print address bit 1


	fprintf(output_mem, "%c", hex2char((code[K]>>16)%16)); // print address bit 5
	fprintf(output_mem, "%c", hex2char((code[K]>>12)%16)); // print address bit 4
	fprintf(output_mem, "%c", hex2char((code[K]>>8)%16)); // print address bit 3
	fprintf(output_mem, "%c", hex2char((code[K]>>4)%16)); // print address bit 2
	fprintf(output_mem, "%c\n", hex2char((code[K])%16)); // print address bit 1

	}
	

for(K=64; K<1024; K++)
	{
	//fprintf(output_hex, "%0x ", code[K]);
	Count = code[K] ^ (code[K] >> 8) ^ (intKey >>16) ^ (intKey >>24);
	code[K]= (code[K] ^ intKey) & 0x3FFFF;
	if (Count==0)
		Count = 0xFF;
	else Count--;
	
	for(i=0;i<=Count;i++)
		intKey= (intKey & 0xFFFFFFBB) ^ (intKey >>1) ^ (intKey <<1);
		
//	fprintf(output_hex, "%0x \n", code[K]);

	fprintf(output_hex, "%c", hex2char((code[K]>>16)%16)); // print address bit 5
	fprintf(output_hex, "%c", hex2char((code[K]>>12)%16)); // print address bit 4
	fprintf(output_hex, "%c", hex2char((code[K]>>8)%16)); // print address bit 3
	fprintf(output_hex, "%c", hex2char((code[K]>>4)%16)); // print address bit 2
	fprintf(output_hex, "%c\n", hex2char((code[K])%16)); // print address bit 1

	fprintf(output_mem, "%c", hex2char((code[K]>>16)%16)); // print address bit 5
	fprintf(output_mem, "%c", hex2char((code[K]>>12)%16)); // print address bit 4
	fprintf(output_mem, "%c", hex2char((code[K]>>8)%16)); // print address bit 3
	fprintf(output_mem, "%c", hex2char((code[K]>>4)%16)); // print address bit 2
	fprintf(output_mem, "%c\n", hex2char((code[K])%16)); // print address bit 1

/*
	printf("Start code[%d] = %#x, intKey = %#x\n\r", K, code[K], intKey);
	Count = code[K] ^ (code[K] >> 8) ^ (intKey >>16) ^ (intKey >>24);
	printf("Count = code[K] ^ (code[K] >> 8) ^ (intKey >>16) ^ (intKey >>24)\n\r");
	printf("%#x = %#x ^ (%#x) ^ (%#x) ^ (%#x)\n\r", Count, code[K], code[K] >> 8, intKey >>16, intKey >>24);

	printf("(code[K] ^ intKey) & 0x3FFFF = code[K]\n\r");
	printf("(%#x ^ %#x) & 0x3FFFF ", code[K], intKey);
	code[K]= (code[K] ^ intKey) & 0x3FFFF;
	printf(" = %#x\n\r",code[K]);

	if (Count==0)
		Count = 0xFF;
	else Count--;
	
	for(i=0;i<=Count;i++)
		{
		intKey= (intKey & 0xFFFFFFBB) ^ (intKey >>1) ^ (intKey <<1);
		printf("Count = %d, intkey = %#x, (intKey & 0xFFFFFFBB) ^ (intKey >>1) ^ (intKey <<1)\n\r", Count, intKey); 
		}
		
	printf("End \n\r", code[K]);
	printf("=========================================================================\n\r");
*/
	}

fclose(output_mem);
fclose(output_hex);
fclose(in);

sign(out_hex);	
	return 0;	

}


