--
-- Definition of a single port ROM for KCPSM-II program defined by load1.psm
-- and assmbled using KCPSM2 assembler.
--
--CB Modified to allow the KCPSM-II to read and write the program space
--
-- Standard IEEE libraries
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--
-- The Unisim Library is used to define Xilinx primitives. It is also used during
-- simulation. The source can be viewed at %XILINX%\vhdl\src\unisims\unisim_VCOMP.vhd
--  
library unisim;
use unisim.vcomponents.all;
--
--
entity load1 is
    Port (      address : in std_logic_vector(9 downto 0);
            instruction : out std_logic_vector(17 downto 0);
                     di : in std_logic_vector(8 downto 0):="111111111";
                     do : out std_logic_vector(8 downto 0);
                     wa : in std_logic_vector(10 downto 0):="11111111111";
                     we : in std_logic:='0';
                   nclk : in std_logic;
                    clk : in std_logic);
    end load1;
--
architecture low_level_definition of load1 is
--
-- Attributes to define ROM contents during implementation synthesis. 
-- The information is repeated in the generic map for functional simulation
--
attribute INIT_00 : string; 
attribute INIT_01 : string; 
attribute INIT_02 : string; 
attribute INIT_03 : string; 
attribute INIT_04 : string; 
attribute INIT_05 : string; 
attribute INIT_06 : string; 
attribute INIT_07 : string; 
attribute INIT_08 : string; 
attribute INIT_09 : string; 
attribute INIT_0A : string; 
attribute INIT_0B : string; 
attribute INIT_0C : string; 
attribute INIT_0D : string; 
attribute INIT_0E : string; 
attribute INIT_0F : string; 
attribute INIT_10 : string; 
attribute INIT_11 : string; 
attribute INIT_12 : string; 
attribute INIT_13 : string; 
attribute INIT_14 : string; 
attribute INIT_15 : string; 
attribute INIT_16 : string; 
attribute INIT_17 : string; 
attribute INIT_18 : string; 
attribute INIT_19 : string; 
attribute INIT_1A : string; 
attribute INIT_1B : string; 
attribute INIT_1C : string; 
attribute INIT_1D : string; 
attribute INIT_1E : string; 
attribute INIT_1F : string; 
attribute INIT_20 : string; 
attribute INIT_21 : string; 
attribute INIT_22 : string; 
attribute INIT_23 : string; 
attribute INIT_24 : string; 
attribute INIT_25 : string; 
attribute INIT_26 : string; 
attribute INIT_27 : string; 
attribute INIT_28 : string; 
attribute INIT_29 : string; 
attribute INIT_2A : string; 
attribute INIT_2B : string; 
attribute INIT_2C : string; 
attribute INIT_2D : string; 
attribute INIT_2E : string; 
attribute INIT_2F : string; 
attribute INIT_30 : string; 
attribute INIT_31 : string; 
attribute INIT_32 : string; 
attribute INIT_33 : string; 
attribute INIT_34 : string; 
attribute INIT_35 : string; 
attribute INIT_36 : string; 
attribute INIT_37 : string; 
attribute INIT_38 : string; 
attribute INIT_39 : string; 
attribute INIT_3A : string; 
attribute INIT_3B : string; 
attribute INIT_3C : string; 
attribute INIT_3D : string; 
attribute INIT_3E : string; 
attribute INIT_3F : string; 
attribute INITP_00 : string;
attribute INITP_01 : string;
attribute INITP_02 : string;
attribute INITP_03 : string;
attribute INITP_04 : string;
attribute INITP_05 : string;
attribute INITP_06 : string;
attribute INITP_07 : string;
attribute xc_props : STRING;
--
-- Attributes to define ROM contents during implementation synthesis.
--
attribute INIT_00 of ram_1024_x_18 : label is  "3FF8621D54143FF861E154143FF862C83F021F0150033F021F0254003F021F02";
attribute INIT_01 of ram_1024_x_18 : label is  "0BFE04EF05CD06AB0789006701450223030140003F021F0140003F021F035414";
attribute INIT_02 of ram_1024_x_18 : label is  "17383F787FFF1F381D1410C311D212E113F00C100D320E540F76089809BA0ADC";
attribute INIT_03 of ram_1024_x_18 : label is  "7FFF1F2055F8354815283F687FFF1F2856F8365016303F707FFF1F3057F83758";
attribute INIT_04 of ram_1024_x_18 : label is  "16307778775817381D14542CDD01609CB45AB582B679979954F8344014203F60";
attribute INIT_05 of ram_1024_x_18 : label is  "1D14544CDD01609CB46EB5D9B6EB97A174607440142075687548152876707650";
attribute INIT_06 of ram_1024_x_18 : label is  "56F83F701F5056F83F701F303650163057F83F781F5857F83F781F3837581738";
attribute INIT_07 of ram_1024_x_18 : label is  "54F83F601F4054F83F601F203440142055F83F681F4855F83F681F2835481528";
attribute INIT_08 of ram_1024_x_18 : label is  "754815287670765016307778775817381D145460DD01609CB48FB51BB6BC97DC";
attribute INIT_09 of ram_1024_x_18 : label is  "B480B588B690979840005488DD01609CB4CAB562B6C197D67460744014207568";
attribute INIT_0A of ram_1024_x_18 : label is  "DE0187088608850884088702870C1E020C400D480E500F581060116812701378";
attribute INIT_0B of ram_1024_x_18 : label is  "DE01A30080008100820083061E050400050806100718082009280A300B3854A9";
attribute INIT_0C of ram_1024_x_18 : label is  "1F8A77F81F8BA0A0A1A8A2B083B81480158116821783A0A0A1A8A2B083B854BA";
attribute INIT_0D of ram_1024_x_18 : label is  "1FB677F81FB774F81FA075F81FA176F81FA277F81FA374F81F8875F81F8976F8";
attribute INIT_0E of ram_1024_x_18 : label is  "DEBB3FF0DE041FF09EC01EC4B700940095009600970674F81FB475F81FB576F8";
attribute INIT_0F of ram_1024_x_18 : label is  "5D019F0C1E083FE862EC9DC81DF8170062F61F33400034BC35BD36BE37BF54EB";
attribute INIT_10 of ram_1024_x_18 : label is  "62ED1F0062ED1F0062ED1FF062F5400054FADDC754FEDE0177315D0497067780";
attribute INIT_11 of ram_1024_x_18 : label is  "62ED613E1FD362ED613E1FD21720160262ED1F0F62F540005511DD0162EC1D98";
attribute INIT_12 of ram_1024_x_18 : label is  "62ED1FAA62F5413E7FFF62EC613E7FFF62EC5521DDCF62ED613E1FE89DD01DF8";
attribute INIT_13 of ram_1024_x_18 : label is  "9F0C1E087FFF62EC613E7FFF62EC5533DDDF613E3FE862EC9DE01DF517FE1601";
attribute INIT_14 of ram_1024_x_18 : label is  "1FD517DE160362ED1FA562F54000553FDE01770576805D479600970676805D42";
attribute INIT_15 of ram_1024_x_18 : label is  "613E7FFF62EC613E7FFF62EC5556DD01613E62EC1D2162ED613E1FD662ED613E";
attribute INIT_16 of ram_1024_x_18 : label is  "556ADD933FE8613E62EC9D941DEC5565DD0163291BFA1D081700160036D137D0";
attribute INIT_17 of ram_1024_x_18 : label is  "62ED1F5A62F540003F9762EC3F9662EC36953794613E7FFF62EC613E7FFF62EC";
attribute INIT_18 of ram_1024_x_18 : label is  "400016F862EC17F862EC5587DD0163291BFA1D2862ED1FD462ED1FD362ED1FD2";
attribute INIT_19 of ram_1024_x_18 : label is  "16F862EC17F862EC5598DD0163291BFA1D3062ED1FD362ED1FD262ED1F3362F5";
attribute INIT_1A of ram_1024_x_18 : label is  "1F9855ABDD0163291BFA1D0862ED1FD462ED1FD362ED1FD262ED1F5562F54000";
attribute INIT_1B of ram_1024_x_18 : label is  "1F5862ED1F6062ED1F6862ED1F7062ED1F7862ED1F8062ED1F8862ED1F9062ED";
attribute INIT_1C of ram_1024_x_18 : label is  "1F1862ED1F2062ED1F2862ED1F3062ED1F3862ED1F4062ED1F4862ED1F5062ED";
attribute INIT_1D of ram_1024_x_18 : label is  "16F862EC17F862EC55D8DD0163291BFA1D2862ED1F0062ED1F0862ED1F1062ED";
attribute INIT_1E of ram_1024_x_18 : label is  "1F0D3FCC1F0C3FCB1F0B3FCA1F0A3FC91F093FC81F083FD31F003FD21F804000";
attribute INIT_1F of ram_1024_x_18 : label is  "3FD21F8060F6617D3FD41F5F3FD31F003FD21F8061153FCF1F0F3FCE1F0E3FCD";
attribute INIT_20 of ram_1024_x_18 : label is  "3FCE1FC63FCD1FC53FCC1FC43FCB1FC33FCA1FC23FC91FC13FC81FC03FD31F00";
attribute INIT_21 of ram_1024_x_18 : label is  "1F0862AA60F640005FB01FB876AA77AA61903FD31F003FD21F0061153FCF1FC7";
attribute INIT_22 of ram_1024_x_18 : label is  "1FC03FB31F0F3FB21F0E3FB11F0D3FB01F0C3F831F0B3F821F0A3F811F093F80";
attribute INIT_23 of ram_1024_x_18 : label is  "3FAF1FC73FAE1FC63FAD1FC53FAC1FC43FAB1FC33FAA1FC23FA91FC13FA83F3F";
attribute INIT_24 of ram_1024_x_18 : label is  "31823281338062AA61155646DDCF3FE81F039DD01DF83FD31F003FD21F806017";
attribute INIT_25 of ram_1024_x_18 : label is  "1FC43FAC1FC33FAB1FC23FAA1FC13FA91FC03FA81F402CB32DB22EB12FB03083";
attribute INIT_26 of ram_1024_x_18 : label is  "17F87F001F93614A60173FB61FCE3FB51FCD3FB41FCC3FAF1FC63FAE1FC53FAD";
attribute INIT_27 of ram_1024_x_18 : label is  "1F8D57F87F281F8E57F87F201F8F57F87F181F9057F87F101F9157F87F081F92";
attribute INIT_28 of ram_1024_x_18 : label is  "7F581F8857F87F501F8957F87F481F8A57F87F401F8B57F87F381F8C57F87F30";
attribute INIT_29 of ram_1024_x_18 : label is  "57F87F801F8357F87F781F8457F87F701F8557F87F681F8657F87F601F8757F8";
attribute INIT_2A of ram_1024_x_18 : label is  "56ACDEBF3FF09EC01EC01F0040005FB87F981F8057F87F901F8157F87F881F82";
attribute INIT_2B of ram_1024_x_18 : label is  "1FFF40003FBF1FB83FBE1F013FB71F803FB63FB53FB43FA73FA63FA53FA41FFF";
attribute INIT_2C of ram_1024_x_18 : label is  "C0011BF0170163291B0F631F6328632742D962D962D962D962D962D962D962D9";
attribute INIT_2D of ram_1024_x_18 : label is  "1B0E631F632263245EE69F029F0C40001FB862C01F3C632856D03BD837F81F02";
attribute INIT_2E of ram_1024_x_18 : label is  "6308630863081FFF431F9F0E63291B3C632E632443291B2D9F08940C14026329";
attribute INIT_2F of ram_1024_x_18 : label is  "1602C0011B18170163291B02631F63291B30632E1FCC43086308630863086308";
attribute INIT_30 of ram_1024_x_18 : label is  "570E3BD8C0011B0163245F1A9F029F0C40001FB862ED63291B1856FF3BD837B0";
attribute INIT_31 of ram_1024_x_18 : label is  "15019F0E63291B06632E632443291B049F08940C14026325631F53113BD8632E";
attribute INIT_32 of ram_1024_x_18 : label is  "350215004000C000572A3BD8C0011BF0632E43291B01631F4325632E40003502";
attribute INIT_33 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000C001DB014000";
attribute INIT_34 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_35 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_36 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_37 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_38 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_39 of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3A of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3B of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3C of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3D of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3E of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3F of ram_1024_x_18 : label is  "4331000000000000000000000000000000000000000000000000000000000000";
attribute INITP_00 of ram_1024_x_18 : label is "555555555555555533005555553300551551551551000000000038E37DF78CB2";
attribute INITP_01 of ram_1024_x_18 : label is "E3C0CAAB3302A999999999999956A9570AA155572AA8555555B3005555553300";
attribute INITP_02 of ram_1024_x_18 : label is "CEBBACF3CFC3300ACF3CF3EF833B03A383CF3F00CF3CF3F0FBE0CECCCCCECC38";
attribute INITP_03 of ram_1024_x_18 : label is "8F888EAAAAAAAA2277CC37777777777777777777730EEECE77CC3BB39DF30EEE";
attribute INITP_04 of ram_1024_x_18 : label is "965965965BEAAAAAAAAAA2AAABF38223AAAAAAA8AAAAAAAABE50E23AAAAAAAA8";
attribute INITP_05 of ram_1024_x_18 : label is "B0CF33FFFCECFCAB3FEA73D6C33FFFFF2888AAA8CC0965965965965965965965";
attribute INITP_06 of ram_1024_x_18 : label is "00000000000000000000000000000000000000228BDCF3FA2CFCABF7DCFA9F35";
attribute INITP_07 of ram_1024_x_18 : label is "C000000000000000000000000000000000000000000000000000000000000000";
attribute xc_props of ram_1024_x_18 : label is "WRITE_MODE_A=READ_FIRST,WRITE_MODE_B=READ_FIRST";
--
begin
--
  --Instantiate the Xilinx primitive for a block RAM
  ram_1024_x_18: RAMB16_S9_S18
  --synthesis translate_off
  --translate_off
  --INIT values repeated to define contents for functional simulation
  generic map (INIT_00 => X"3FF8621D54143FF861E154143FF862C83F021F0150033F021F0254003F021F02",
               INIT_01 => X"0BFE04EF05CD06AB0789006701450223030140003F021F0140003F021F035414",
               INIT_02 => X"17383F787FFF1F381D1410C311D212E113F00C100D320E540F76089809BA0ADC",
               INIT_03 => X"7FFF1F2055F8354815283F687FFF1F2856F8365016303F707FFF1F3057F83758",
               INIT_04 => X"16307778775817381D14542CDD01609CB45AB582B679979954F8344014203F60",
               INIT_05 => X"1D14544CDD01609CB46EB5D9B6EB97A174607440142075687548152876707650",
               INIT_06 => X"56F83F701F5056F83F701F303650163057F83F781F5857F83F781F3837581738",
               INIT_07 => X"54F83F601F4054F83F601F203440142055F83F681F4855F83F681F2835481528",
               INIT_08 => X"754815287670765016307778775817381D145460DD01609CB48FB51BB6BC97DC",
               INIT_09 => X"B480B588B690979840005488DD01609CB4CAB562B6C197D67460744014207568",
               INIT_0A => X"DE0187088608850884088702870C1E020C400D480E500F581060116812701378",
               INIT_0B => X"DE01A30080008100820083061E050400050806100718082009280A300B3854A9",
               INIT_0C => X"1F8A77F81F8BA0A0A1A8A2B083B81480158116821783A0A0A1A8A2B083B854BA",
               INIT_0D => X"1FB677F81FB774F81FA075F81FA176F81FA277F81FA374F81F8875F81F8976F8",
               INIT_0E => X"DEBB3FF0DE041FF09EC01EC4B700940095009600970674F81FB475F81FB576F8",
               INIT_0F => X"5D019F0C1E083FE862EC9DC81DF8170062F61F33400034BC35BD36BE37BF54EB",
               INIT_10 => X"62ED1F0062ED1F0062ED1FF062F5400054FADDC754FEDE0177315D0497067780",
               INIT_11 => X"62ED613E1FD362ED613E1FD21720160262ED1F0F62F540005511DD0162EC1D98",
               INIT_12 => X"62ED1FAA62F5413E7FFF62EC613E7FFF62EC5521DDCF62ED613E1FE89DD01DF8",
               INIT_13 => X"9F0C1E087FFF62EC613E7FFF62EC5533DDDF613E3FE862EC9DE01DF517FE1601",
               INIT_14 => X"1FD517DE160362ED1FA562F54000553FDE01770576805D479600970676805D42",
               INIT_15 => X"613E7FFF62EC613E7FFF62EC5556DD01613E62EC1D2162ED613E1FD662ED613E",
               INIT_16 => X"556ADD933FE8613E62EC9D941DEC5565DD0163291BFA1D081700160036D137D0",
               INIT_17 => X"62ED1F5A62F540003F9762EC3F9662EC36953794613E7FFF62EC613E7FFF62EC",
               INIT_18 => X"400016F862EC17F862EC5587DD0163291BFA1D2862ED1FD462ED1FD362ED1FD2",
               INIT_19 => X"16F862EC17F862EC5598DD0163291BFA1D3062ED1FD362ED1FD262ED1F3362F5",
               INIT_1A => X"1F9855ABDD0163291BFA1D0862ED1FD462ED1FD362ED1FD262ED1F5562F54000",
               INIT_1B => X"1F5862ED1F6062ED1F6862ED1F7062ED1F7862ED1F8062ED1F8862ED1F9062ED",
               INIT_1C => X"1F1862ED1F2062ED1F2862ED1F3062ED1F3862ED1F4062ED1F4862ED1F5062ED",
               INIT_1D => X"16F862EC17F862EC55D8DD0163291BFA1D2862ED1F0062ED1F0862ED1F1062ED",
               INIT_1E => X"1F0D3FCC1F0C3FCB1F0B3FCA1F0A3FC91F093FC81F083FD31F003FD21F804000",
               INIT_1F => X"3FD21F8060F6617D3FD41F5F3FD31F003FD21F8061153FCF1F0F3FCE1F0E3FCD",
               INIT_20 => X"3FCE1FC63FCD1FC53FCC1FC43FCB1FC33FCA1FC23FC91FC13FC81FC03FD31F00",
               INIT_21 => X"1F0862AA60F640005FB01FB876AA77AA61903FD31F003FD21F0061153FCF1FC7",
               INIT_22 => X"1FC03FB31F0F3FB21F0E3FB11F0D3FB01F0C3F831F0B3F821F0A3F811F093F80",
               INIT_23 => X"3FAF1FC73FAE1FC63FAD1FC53FAC1FC43FAB1FC33FAA1FC23FA91FC13FA83F3F",
               INIT_24 => X"31823281338062AA61155646DDCF3FE81F039DD01DF83FD31F003FD21F806017",
               INIT_25 => X"1FC43FAC1FC33FAB1FC23FAA1FC13FA91FC03FA81F402CB32DB22EB12FB03083",
               INIT_26 => X"17F87F001F93614A60173FB61FCE3FB51FCD3FB41FCC3FAF1FC63FAE1FC53FAD",
               INIT_27 => X"1F8D57F87F281F8E57F87F201F8F57F87F181F9057F87F101F9157F87F081F92",
               INIT_28 => X"7F581F8857F87F501F8957F87F481F8A57F87F401F8B57F87F381F8C57F87F30",
               INIT_29 => X"57F87F801F8357F87F781F8457F87F701F8557F87F681F8657F87F601F8757F8",
               INIT_2A => X"56ACDEBF3FF09EC01EC01F0040005FB87F981F8057F87F901F8157F87F881F82",
               INIT_2B => X"1FFF40003FBF1FB83FBE1F013FB71F803FB63FB53FB43FA73FA63FA53FA41FFF",
               INIT_2C => X"C0011BF0170163291B0F631F6328632742D962D962D962D962D962D962D962D9",
               INIT_2D => X"1B0E631F632263245EE69F029F0C40001FB862C01F3C632856D03BD837F81F02",
               INIT_2E => X"6308630863081FFF431F9F0E63291B3C632E632443291B2D9F08940C14026329",
               INIT_2F => X"1602C0011B18170163291B02631F63291B30632E1FCC43086308630863086308",
               INIT_30 => X"570E3BD8C0011B0163245F1A9F029F0C40001FB862ED63291B1856FF3BD837B0",
               INIT_31 => X"15019F0E63291B06632E632443291B049F08940C14026325631F53113BD8632E",
               INIT_32 => X"350215004000C000572A3BD8C0011BF0632E43291B01631F4325632E40003502",
               INIT_33 => X"0000000000000000000000000000000000000000000000000000C001DB014000",
               INIT_34 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_35 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_36 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_37 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_38 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_39 => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3A => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3B => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3C => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3D => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3E => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3F => X"4331000000000000000000000000000000000000000000000000000000000000",    
               INITP_00 => X"555555555555555533005555553300551551551551000000000038E37DF78CB2",
               INITP_01 => X"E3C0CAAB3302A999999999999956A9570AA155572AA8555555B3005555553300",
               INITP_02 => X"CEBBACF3CFC3300ACF3CF3EF833B03A383CF3F00CF3CF3F0FBE0CECCCCCECC38",
               INITP_03 => X"8F888EAAAAAAAA2277CC37777777777777777777730EEECE77CC3BB39DF30EEE",
               INITP_04 => X"965965965BEAAAAAAAAAA2AAABF38223AAAAAAA8AAAAAAAABE50E23AAAAAAAA8",
               INITP_05 => X"B0CF33FFFCECFCAB3FEA73D6C33FFFFF2888AAA8CC0965965965965965965965",
               INITP_06 => X"00000000000000000000000000000000000000228BDCF3FA2CFCABF7DCFA9F35",
               INITP_07 => X"C000000000000000000000000000000000000000000000000000000000000000",
               WRITE_MODE_A => "READ_FIRST",
               WRITE_MODE_B => "READ_FIRST")
  --translate_on
  --synthesis translate_on
-- synthesis translate_on
  port map(   DIA => di(7 downto 0),
             DIPA => di(8 downto 8),
              ENA => '1',
              WEA => we,
             SSRA => '0',
             CLKA => nclk,
            ADDRA => wa,
              DOA => do(7 downto 0),
             DOPA => do(8 downto 8),
              DIB => "1111111111111111",
             DIPB => "11",
              ENB => '1',
              WEB => '0',
             SSRB => '0',
             CLKB => clk,
            ADDRB => address,
              DOB => instruction(15 downto 0),
             DOPB => instruction(17 downto 16)); 
--
end low_level_definition;
--
------------------------------------------------------------------------------------
--
-- END OF FILE load1.vhd
--
------------------------------------------------------------------------------------
