--
-- Definition of a single port ROM for KCPSM-II program defined by sha1.psm
-- and assmbled using KCPSM2 assembler.
--
--CB Modified to allow the KCPSM-II to read and write the program space
--
-- Standard IEEE libraries
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--
-- The Unisim Library is used to define Xilinx primitives. It is also used during
-- simulation. The source can be viewed at %XILINX%\vhdl\src\unisims\unisim_VCOMP.vhd
--  
library unisim;
use unisim.vcomponents.all;
--
--
entity sha1 is
    Port (      address : in std_logic_vector(9 downto 0);
            instruction : out std_logic_vector(17 downto 0);
                     di : in std_logic_vector(8 downto 0):="111111111";
                     do : out std_logic_vector(8 downto 0);
                     wa : in std_logic_vector(10 downto 0):="11111111111";
                     we : in std_logic:='0';
                   nclk : in std_logic;
                    clk : in std_logic);
    end sha1;
--
architecture low_level_definition of sha1 is
--
-- Attributes to define ROM contents during implementation synthesis. 
-- The information is repeated in the generic map for functional simulation
--
attribute INIT_00 : string; 
attribute INIT_01 : string; 
attribute INIT_02 : string; 
attribute INIT_03 : string; 
attribute INIT_04 : string; 
attribute INIT_05 : string; 
attribute INIT_06 : string; 
attribute INIT_07 : string; 
attribute INIT_08 : string; 
attribute INIT_09 : string; 
attribute INIT_0A : string; 
attribute INIT_0B : string; 
attribute INIT_0C : string; 
attribute INIT_0D : string; 
attribute INIT_0E : string; 
attribute INIT_0F : string; 
attribute INIT_10 : string; 
attribute INIT_11 : string; 
attribute INIT_12 : string; 
attribute INIT_13 : string; 
attribute INIT_14 : string; 
attribute INIT_15 : string; 
attribute INIT_16 : string; 
attribute INIT_17 : string; 
attribute INIT_18 : string; 
attribute INIT_19 : string; 
attribute INIT_1A : string; 
attribute INIT_1B : string; 
attribute INIT_1C : string; 
attribute INIT_1D : string; 
attribute INIT_1E : string; 
attribute INIT_1F : string; 
attribute INIT_20 : string; 
attribute INIT_21 : string; 
attribute INIT_22 : string; 
attribute INIT_23 : string; 
attribute INIT_24 : string; 
attribute INIT_25 : string; 
attribute INIT_26 : string; 
attribute INIT_27 : string; 
attribute INIT_28 : string; 
attribute INIT_29 : string; 
attribute INIT_2A : string; 
attribute INIT_2B : string; 
attribute INIT_2C : string; 
attribute INIT_2D : string; 
attribute INIT_2E : string; 
attribute INIT_2F : string; 
attribute INIT_30 : string; 
attribute INIT_31 : string; 
attribute INIT_32 : string; 
attribute INIT_33 : string; 
attribute INIT_34 : string; 
attribute INIT_35 : string; 
attribute INIT_36 : string; 
attribute INIT_37 : string; 
attribute INIT_38 : string; 
attribute INIT_39 : string; 
attribute INIT_3A : string; 
attribute INIT_3B : string; 
attribute INIT_3C : string; 
attribute INIT_3D : string; 
attribute INIT_3E : string; 
attribute INIT_3F : string; 
attribute INITP_00 : string;
attribute INITP_01 : string;
attribute INITP_02 : string;
attribute INITP_03 : string;
attribute INITP_04 : string;
attribute INITP_05 : string;
attribute INITP_06 : string;
attribute INITP_07 : string;
attribute xc_props : STRING;
--
-- Attributes to define ROM contents during implementation synthesis.
--
attribute INIT_00 of ram_1024_x_18 : label is  "DF015054DF015063DF015188DF01504BDF015348DF01501CDF014000600363B9";
attribute INIT_01 of ram_1024_x_18 : label is  "3FF063B99EC01EC040005094DF015092DF015091DF015088DF01506EDF01507D";
attribute INIT_02 of ram_1024_x_18 : label is  "1F3063B41F2863B41F2063B41F1863B41F1063B41F0863B41F006096541DDEBF";
attribute INIT_03 of ram_1024_x_18 : label is  "1F7063B41F6863B41F6063B41F5863B41F5063B41F4863B41F4063B41F3863B4";
attribute INIT_04 of ram_1024_x_18 : label is  "63B41FE89DC81DF8617543B41F9863B41F9063B41F8863B41F8063B41F7863B4";
attribute INIT_05 of ram_1024_x_18 : label is  "1FB861955459DDCF3FE863B99DD01DF83FD363B93FD263B943B41FB8544DDDC7";
attribute INIT_06 of ram_1024_x_18 : label is  "3FD563B943B41FB063B41FB85465DDDF63B41FE89DE01DF561AD43B41FB063B4";
attribute INIT_07 of ram_1024_x_18 : label is  "63B93FD263B943B41FD163B41FD05474DD9763B41FE89D981DE861CA3FD663B9";
attribute INIT_08 of ram_1024_x_18 : label is  "1FB063B41FB862103FD363B93FD263B943B41FB063B41FB861FD3FD463B93FD3";
attribute INIT_09 of ram_1024_x_18 : label is  "0ADC0BFE04EF05CD06AB0789006701450223030143B4629D43B46261400043B4";
attribute INIT_0A of ram_1024_x_18 : label is  "375817383F787FFF1F381D1410C311D212E113F00C100D320E540F76089809BA";
attribute INIT_0B of ram_1024_x_18 : label is  "3F607FFF1F2055F8354815283F687FFF1F2856F8365016303F707FFF1F3057F8";
attribute INIT_0C of ram_1024_x_18 : label is  "765016307778775817381D1454ABDD01611BB45AB582B679979954F834401420";
attribute INIT_0D of ram_1024_x_18 : label is  "17381D1454CBDD01611BB46EB5D9B6EB97A17460744014207568754815287670";
attribute INIT_0E of ram_1024_x_18 : label is  "152856F83F701F5056F83F701F303650163057F83F781F5857F83F781F383758";
attribute INIT_0F of ram_1024_x_18 : label is  "97DC54F83F601F4054F83F601F203440142055F83F681F4855F83F681F283548";
attribute INIT_10 of ram_1024_x_18 : label is  "7568754815287670765016307778775817381D1454DFDD01611BB48FB51BB6BC";
attribute INIT_11 of ram_1024_x_18 : label is  "1378B480B588B690979840005507DD01611BB4CAB562B6C197D6746074401420";
attribute INIT_12 of ram_1024_x_18 : label is  "5528DE0187088608850884088702870C1E020C400D480E500F58106011681270";
attribute INIT_13 of ram_1024_x_18 : label is  "5539DE01A30080008100820083061E050400050806100718082009280A300B38";
attribute INIT_14 of ram_1024_x_18 : label is  "76F81F8A77F81F8BA0A0A1A8A2B083B81480158116821783A0A0A1A8A2B083B8";
attribute INIT_15 of ram_1024_x_18 : label is  "76F81FB677F81FB774F81FA075F81FA176F81FA277F81FA374F81F8875F81F89";
attribute INIT_16 of ram_1024_x_18 : label is  "556ADEBB3FF0DE041FF09EC01EC4B700940095009600970674F81FB475F81FB5";
attribute INIT_17 of ram_1024_x_18 : label is  "77805D809F0C1E083FE8636D9DC81DF8170063771F33400034BC35BD36BE37BF";
attribute INIT_18 of ram_1024_x_18 : label is  "1D98636E1F00636E1F00636E1FF0637640005579DDC7557DDE0177315D839706";
attribute INIT_19 of ram_1024_x_18 : label is  "636E61BE1FD3636E61BE1FD217201602636E1F0F637640005590DD0163B4636D";
attribute INIT_1A of ram_1024_x_18 : label is  "636E1FAA637641BE7FFF636D61BE7FFF636D55A1DDCF636E61BE1FE89DD01DF8";
attribute INIT_1B of ram_1024_x_18 : label is  "9F0C1E087FFF636D61BE7FFF636D55B3DDDF61BE3FE8636D9DE01DF517FE1601";
attribute INIT_1C of ram_1024_x_18 : label is  "1FD517DE1603636E1FA56376400055BFDE01770576805DC79600970676805DC2";
attribute INIT_1D of ram_1024_x_18 : label is  "61BE7FFF636D61BE7FFF636D55D6DD0161BE636D1D21636E61BE1FD6636E61BE";
attribute INIT_1E of ram_1024_x_18 : label is  "55EADD933FE861BE636D9D941DEC55E5DD0163AA1BFA1D081700160036D137D0";
attribute INIT_1F of ram_1024_x_18 : label is  "636E1F5A637640003F97636D3F96636D3695379461BE7FFF636D61BE7FFF636D";
attribute INIT_20 of ram_1024_x_18 : label is  "400016F8636D17F8636D5607DD0163AA1BFA1D28636E1FD4636E1FD3636E1FD2";
attribute INIT_21 of ram_1024_x_18 : label is  "16F8636D17F8636D5618DD0163AA1BFA1D30636E1FD3636E1FD2636E1F336376";
attribute INIT_22 of ram_1024_x_18 : label is  "1F98562BDD0163AA1BFA1D08636E1FD4636E1FD3636E1FD2636E1F5563764000";
attribute INIT_23 of ram_1024_x_18 : label is  "1F58636E1F60636E1F68636E1F70636E1F78636E1F80636E1F88636E1F90636E";
attribute INIT_24 of ram_1024_x_18 : label is  "1F18636E1F20636E1F28636E1F30636E1F38636E1F40636E1F48636E1F50636E";
attribute INIT_25 of ram_1024_x_18 : label is  "16F8636D17F8636D5658DD0163AA1BFA1D28636E1F00636E1F08636E1F10636E";
attribute INIT_26 of ram_1024_x_18 : label is  "1F0D3FCC1F0C3FCB1F0B3FCA1F0A3FC91F093FC81F083FD31F003FD21F804000";
attribute INIT_27 of ram_1024_x_18 : label is  "3FD21F80617561FD3FD41F5F3FD31F003FD21F8061953FCF1F0F3FCE1F0E3FCD";
attribute INIT_28 of ram_1024_x_18 : label is  "3FCE1FC63FCD1FC53FCC1FC43FCB1FC33FCA1FC23FC91FC13FC81FC03FD31F00";
attribute INIT_29 of ram_1024_x_18 : label is  "1F08632A617540005FB01FB876AA77AA62103FD31F003FD21F0061953FCF1FC7";
attribute INIT_2A of ram_1024_x_18 : label is  "1FC03FB31F0F3FB21F0E3FB11F0D3FB01F0C3F831F0B3F821F0A3F811F093F80";
attribute INIT_2B of ram_1024_x_18 : label is  "3FAF1FC73FAE1FC63FAD1FC53FAC1FC43FAB1FC33FAA1FC23FA91FC13FA83F3F";
attribute INIT_2C of ram_1024_x_18 : label is  "318232813380632A619556C6DDCF3FE81F039DD01DF83FD31F003FD21F806096";
attribute INIT_2D of ram_1024_x_18 : label is  "1FC43FAC1FC33FAB1FC23FAA1FC13FA91FC03FA81F402CB32DB22EB12FB03083";
attribute INIT_2E of ram_1024_x_18 : label is  "17F87F001F9361CA60963FB61FCE3FB51FCD3FB41FCC3FAF1FC63FAE1FC53FAD";
attribute INIT_2F of ram_1024_x_18 : label is  "1F8D57F87F281F8E57F87F201F8F57F87F181F9057F87F101F9157F87F081F92";
attribute INIT_30 of ram_1024_x_18 : label is  "7F581F8857F87F501F8957F87F481F8A57F87F401F8B57F87F381F8C57F87F30";
attribute INIT_31 of ram_1024_x_18 : label is  "57F87F801F8357F87F781F8457F87F701F8557F87F681F8657F87F601F8757F8";
attribute INIT_32 of ram_1024_x_18 : label is  "572CDEBF3FF09EC01EC01F0040005FB87F981F8057F87F901F8157F87F881F82";
attribute INIT_33 of ram_1024_x_18 : label is  "1FFF40003FBF1FB83FBE1F013FB71F803FB63FB53FB43FA73FA63FA53FA41FFF";
attribute INIT_34 of ram_1024_x_18 : label is  "C0011BF0170163AA1B0F63A063A963A8435A635A635A635A635A635A635A635A";
attribute INIT_35 of ram_1024_x_18 : label is  "63A063A363A55F679F029F0C400063B41FB863401F3C63A957503BD837F81F02";
attribute INIT_36 of ram_1024_x_18 : label is  "638963891FFF43A09F0E63AA1B3C63AF63A543AA1B2D9F08940C140263AA1B0E";
attribute INIT_37 of ram_1024_x_18 : label is  "C0011B18170163AA1B0263A063AA1B3063AF1FCC438963896389638963896389";
attribute INIT_38 of ram_1024_x_18 : label is  "3BD8C0011B0163A55F9B9F029F0C40001FB8636E63AA1B1857803BD837B01602";
attribute INIT_39 of ram_1024_x_18 : label is  "9F0E63AA1B0663AF63A543AA1B049F08940C140263A663A053923BD863AF578F";
attribute INIT_3A of ram_1024_x_18 : label is  "15004000C00057AB3BD8C0011BF063AF43AA1B0163A043A663AF400035021501";
attribute INIT_3B of ram_1024_x_18 : label is  "0000000040001F0053B93C021C0140003F0053B43C011C01C001DB0140003502";
attribute INIT_3C of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3D of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3E of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3F of ram_1024_x_18 : label is  "43B2000000000000000000000000000000000000000000000000000000000000";
attribute INITP_00 of ram_1024_x_18 : label is "EFBB3C3BBDDCF0F77CF0BBDCF0F77777777777777777777CF0B333333333333F";
attribute INITP_01 of ram_1024_x_18 : label is "15555555555555554CC01555554CC015455455455440000000000FFB77BBDDEE";
attribute INITP_02 of ram_1024_x_18 : label is "38F032AACCC0AA66666666666655AA55C2A85555CAAA1555556CC01555554CC0";
attribute INITP_03 of ram_1024_x_18 : label is "CEBBACF3CFC3300ACF3CF3EF833B03A383CF3F00CF3CF3F0FBE0CECF3333B30E";
attribute INITP_04 of ram_1024_x_18 : label is "8F888EAAAAAAAA2277CC37777777777777777777730EEECE77CC3BB39DF30EEE";
attribute INITP_05 of ram_1024_x_18 : label is "965965965BEAAAAAAAAAA2AAABF38223AAAAAAA8AAAAAAAABE50E23AAAAAAAA8";
attribute INITP_06 of ram_1024_x_18 : label is "C33CCFFFF3B3F2ACFFAB73D6C33FFFFF2888AAA8CC0965965965965965965965";
attribute INITP_07 of ram_1024_x_18 : label is "C00000000000000000000000000000000ACAB28A2F73CFE8B3F2AFDF73EA7CD6";
attribute xc_props of ram_1024_x_18 : label is "WRITE_MODE_A=READ_FIRST,WRITE_MODE_B=READ_FIRST";
--
begin
--
  --Instantiate the Xilinx primitive for a block RAM
  ram_1024_x_18: RAMB16_S9_S18
  --synthesis translate_off
  --translate_off
  --INIT values repeated to define contents for functional simulation
  generic map (INIT_00 => X"DF015054DF015063DF015188DF01504BDF015348DF01501CDF014000600363B9",
               INIT_01 => X"3FF063B99EC01EC040005094DF015092DF015091DF015088DF01506EDF01507D",
               INIT_02 => X"1F3063B41F2863B41F2063B41F1863B41F1063B41F0863B41F006096541DDEBF",
               INIT_03 => X"1F7063B41F6863B41F6063B41F5863B41F5063B41F4863B41F4063B41F3863B4",
               INIT_04 => X"63B41FE89DC81DF8617543B41F9863B41F9063B41F8863B41F8063B41F7863B4",
               INIT_05 => X"1FB861955459DDCF3FE863B99DD01DF83FD363B93FD263B943B41FB8544DDDC7",
               INIT_06 => X"3FD563B943B41FB063B41FB85465DDDF63B41FE89DE01DF561AD43B41FB063B4",
               INIT_07 => X"63B93FD263B943B41FD163B41FD05474DD9763B41FE89D981DE861CA3FD663B9",
               INIT_08 => X"1FB063B41FB862103FD363B93FD263B943B41FB063B41FB861FD3FD463B93FD3",
               INIT_09 => X"0ADC0BFE04EF05CD06AB0789006701450223030143B4629D43B46261400043B4",
               INIT_0A => X"375817383F787FFF1F381D1410C311D212E113F00C100D320E540F76089809BA",
               INIT_0B => X"3F607FFF1F2055F8354815283F687FFF1F2856F8365016303F707FFF1F3057F8",
               INIT_0C => X"765016307778775817381D1454ABDD01611BB45AB582B679979954F834401420",
               INIT_0D => X"17381D1454CBDD01611BB46EB5D9B6EB97A17460744014207568754815287670",
               INIT_0E => X"152856F83F701F5056F83F701F303650163057F83F781F5857F83F781F383758",
               INIT_0F => X"97DC54F83F601F4054F83F601F203440142055F83F681F4855F83F681F283548",
               INIT_10 => X"7568754815287670765016307778775817381D1454DFDD01611BB48FB51BB6BC",
               INIT_11 => X"1378B480B588B690979840005507DD01611BB4CAB562B6C197D6746074401420",
               INIT_12 => X"5528DE0187088608850884088702870C1E020C400D480E500F58106011681270",
               INIT_13 => X"5539DE01A30080008100820083061E050400050806100718082009280A300B38",
               INIT_14 => X"76F81F8A77F81F8BA0A0A1A8A2B083B81480158116821783A0A0A1A8A2B083B8",
               INIT_15 => X"76F81FB677F81FB774F81FA075F81FA176F81FA277F81FA374F81F8875F81F89",
               INIT_16 => X"556ADEBB3FF0DE041FF09EC01EC4B700940095009600970674F81FB475F81FB5",
               INIT_17 => X"77805D809F0C1E083FE8636D9DC81DF8170063771F33400034BC35BD36BE37BF",
               INIT_18 => X"1D98636E1F00636E1F00636E1FF0637640005579DDC7557DDE0177315D839706",
               INIT_19 => X"636E61BE1FD3636E61BE1FD217201602636E1F0F637640005590DD0163B4636D",
               INIT_1A => X"636E1FAA637641BE7FFF636D61BE7FFF636D55A1DDCF636E61BE1FE89DD01DF8",
               INIT_1B => X"9F0C1E087FFF636D61BE7FFF636D55B3DDDF61BE3FE8636D9DE01DF517FE1601",
               INIT_1C => X"1FD517DE1603636E1FA56376400055BFDE01770576805DC79600970676805DC2",
               INIT_1D => X"61BE7FFF636D61BE7FFF636D55D6DD0161BE636D1D21636E61BE1FD6636E61BE",
               INIT_1E => X"55EADD933FE861BE636D9D941DEC55E5DD0163AA1BFA1D081700160036D137D0",
               INIT_1F => X"636E1F5A637640003F97636D3F96636D3695379461BE7FFF636D61BE7FFF636D",
               INIT_20 => X"400016F8636D17F8636D5607DD0163AA1BFA1D28636E1FD4636E1FD3636E1FD2",
               INIT_21 => X"16F8636D17F8636D5618DD0163AA1BFA1D30636E1FD3636E1FD2636E1F336376",
               INIT_22 => X"1F98562BDD0163AA1BFA1D08636E1FD4636E1FD3636E1FD2636E1F5563764000",
               INIT_23 => X"1F58636E1F60636E1F68636E1F70636E1F78636E1F80636E1F88636E1F90636E",
               INIT_24 => X"1F18636E1F20636E1F28636E1F30636E1F38636E1F40636E1F48636E1F50636E",
               INIT_25 => X"16F8636D17F8636D5658DD0163AA1BFA1D28636E1F00636E1F08636E1F10636E",
               INIT_26 => X"1F0D3FCC1F0C3FCB1F0B3FCA1F0A3FC91F093FC81F083FD31F003FD21F804000",
               INIT_27 => X"3FD21F80617561FD3FD41F5F3FD31F003FD21F8061953FCF1F0F3FCE1F0E3FCD",
               INIT_28 => X"3FCE1FC63FCD1FC53FCC1FC43FCB1FC33FCA1FC23FC91FC13FC81FC03FD31F00",
               INIT_29 => X"1F08632A617540005FB01FB876AA77AA62103FD31F003FD21F0061953FCF1FC7",
               INIT_2A => X"1FC03FB31F0F3FB21F0E3FB11F0D3FB01F0C3F831F0B3F821F0A3F811F093F80",
               INIT_2B => X"3FAF1FC73FAE1FC63FAD1FC53FAC1FC43FAB1FC33FAA1FC23FA91FC13FA83F3F",
               INIT_2C => X"318232813380632A619556C6DDCF3FE81F039DD01DF83FD31F003FD21F806096",
               INIT_2D => X"1FC43FAC1FC33FAB1FC23FAA1FC13FA91FC03FA81F402CB32DB22EB12FB03083",
               INIT_2E => X"17F87F001F9361CA60963FB61FCE3FB51FCD3FB41FCC3FAF1FC63FAE1FC53FAD",
               INIT_2F => X"1F8D57F87F281F8E57F87F201F8F57F87F181F9057F87F101F9157F87F081F92",
               INIT_30 => X"7F581F8857F87F501F8957F87F481F8A57F87F401F8B57F87F381F8C57F87F30",
               INIT_31 => X"57F87F801F8357F87F781F8457F87F701F8557F87F681F8657F87F601F8757F8",
               INIT_32 => X"572CDEBF3FF09EC01EC01F0040005FB87F981F8057F87F901F8157F87F881F82",
               INIT_33 => X"1FFF40003FBF1FB83FBE1F013FB71F803FB63FB53FB43FA73FA63FA53FA41FFF",
               INIT_34 => X"C0011BF0170163AA1B0F63A063A963A8435A635A635A635A635A635A635A635A",
               INIT_35 => X"63A063A363A55F679F029F0C400063B41FB863401F3C63A957503BD837F81F02",
               INIT_36 => X"638963891FFF43A09F0E63AA1B3C63AF63A543AA1B2D9F08940C140263AA1B0E",
               INIT_37 => X"C0011B18170163AA1B0263A063AA1B3063AF1FCC438963896389638963896389",
               INIT_38 => X"3BD8C0011B0163A55F9B9F029F0C40001FB8636E63AA1B1857803BD837B01602",
               INIT_39 => X"9F0E63AA1B0663AF63A543AA1B049F08940C140263A663A053923BD863AF578F",
               INIT_3A => X"15004000C00057AB3BD8C0011BF063AF43AA1B0163A043A663AF400035021501",
               INIT_3B => X"0000000040001F0053B93C021C0140003F0053B43C011C01C001DB0140003502",
               INIT_3C => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3D => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3E => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3F => X"43B2000000000000000000000000000000000000000000000000000000000000",    
               INITP_00 => X"EFBB3C3BBDDCF0F77CF0BBDCF0F77777777777777777777CF0B333333333333F",
               INITP_01 => X"15555555555555554CC01555554CC015455455455440000000000FFB77BBDDEE",
               INITP_02 => X"38F032AACCC0AA66666666666655AA55C2A85555CAAA1555556CC01555554CC0",
               INITP_03 => X"CEBBACF3CFC3300ACF3CF3EF833B03A383CF3F00CF3CF3F0FBE0CECF3333B30E",
               INITP_04 => X"8F888EAAAAAAAA2277CC37777777777777777777730EEECE77CC3BB39DF30EEE",
               INITP_05 => X"965965965BEAAAAAAAAAA2AAABF38223AAAAAAA8AAAAAAAABE50E23AAAAAAAA8",
               INITP_06 => X"C33CCFFFF3B3F2ACFFAB73D6C33FFFFF2888AAA8CC0965965965965965965965",
               INITP_07 => X"C00000000000000000000000000000000ACAB28A2F73CFE8B3F2AFDF73EA7CD6",
               WRITE_MODE_A => "READ_FIRST",
               WRITE_MODE_B => "READ_FIRST")
  --translate_on
  --synthesis translate_on
-- synthesis translate_on
  port map(   DIA => di(7 downto 0),
             DIPA => di(8 downto 8),
              ENA => '1',
              WEA => we,
             SSRA => '0',
             CLKA => nclk,
            ADDRA => wa,
              DOA => do(7 downto 0),
             DOPA => do(8 downto 8),
              DIB => "1111111111111111",
             DIPB => "11",
              ENB => '1',
              WEB => '0',
             SSRB => '0',
             CLKB => clk,
            ADDRB => address,
              DOB => instruction(15 downto 0),
             DOPB => instruction(17 downto 16)); 
--
end low_level_definition;
--
------------------------------------------------------------------------------------
--
-- END OF FILE sha1.vhd
--
------------------------------------------------------------------------------------
