--
-- Definition of a single port ROM for KCPSM-II program defined by sha2.psm
-- and assmbled using KCPSM2 assembler.
--
--CB Modified to allow the KCPSM-II to read and write the program space
--
-- Standard IEEE libraries
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--
-- The Unisim Library is used to define Xilinx primitives. It is also used during
-- simulation. The source can be viewed at %XILINX%\vhdl\src\unisims\unisim_VCOMP.vhd
--  
library unisim;
use unisim.vcomponents.all;
--
--
entity sha2 is
    Port (      address : in std_logic_vector(9 downto 0);
            instruction : out std_logic_vector(17 downto 0);
                     di : in std_logic_vector(8 downto 0):="111111111";
                     do : out std_logic_vector(8 downto 0);
                     wa : in std_logic_vector(10 downto 0):="11111111111";
                     we : in std_logic:='0';
                   nclk : in std_logic;
                    clk : in std_logic);
    end sha2;
--
architecture low_level_definition of sha2 is
--
-- Attributes to define ROM contents during implementation synthesis. 
-- The information is repeated in the generic map for functional simulation
--
attribute INIT_00 : string; 
attribute INIT_01 : string; 
attribute INIT_02 : string; 
attribute INIT_03 : string; 
attribute INIT_04 : string; 
attribute INIT_05 : string; 
attribute INIT_06 : string; 
attribute INIT_07 : string; 
attribute INIT_08 : string; 
attribute INIT_09 : string; 
attribute INIT_0A : string; 
attribute INIT_0B : string; 
attribute INIT_0C : string; 
attribute INIT_0D : string; 
attribute INIT_0E : string; 
attribute INIT_0F : string; 
attribute INIT_10 : string; 
attribute INIT_11 : string; 
attribute INIT_12 : string; 
attribute INIT_13 : string; 
attribute INIT_14 : string; 
attribute INIT_15 : string; 
attribute INIT_16 : string; 
attribute INIT_17 : string; 
attribute INIT_18 : string; 
attribute INIT_19 : string; 
attribute INIT_1A : string; 
attribute INIT_1B : string; 
attribute INIT_1C : string; 
attribute INIT_1D : string; 
attribute INIT_1E : string; 
attribute INIT_1F : string; 
attribute INIT_20 : string; 
attribute INIT_21 : string; 
attribute INIT_22 : string; 
attribute INIT_23 : string; 
attribute INIT_24 : string; 
attribute INIT_25 : string; 
attribute INIT_26 : string; 
attribute INIT_27 : string; 
attribute INIT_28 : string; 
attribute INIT_29 : string; 
attribute INIT_2A : string; 
attribute INIT_2B : string; 
attribute INIT_2C : string; 
attribute INIT_2D : string; 
attribute INIT_2E : string; 
attribute INIT_2F : string; 
attribute INIT_30 : string; 
attribute INIT_31 : string; 
attribute INIT_32 : string; 
attribute INIT_33 : string; 
attribute INIT_34 : string; 
attribute INIT_35 : string; 
attribute INIT_36 : string; 
attribute INIT_37 : string; 
attribute INIT_38 : string; 
attribute INIT_39 : string; 
attribute INIT_3A : string; 
attribute INIT_3B : string; 
attribute INIT_3C : string; 
attribute INIT_3D : string; 
attribute INIT_3E : string; 
attribute INIT_3F : string; 
attribute INITP_00 : string;
attribute INITP_01 : string;
attribute INITP_02 : string;
attribute INITP_03 : string;
attribute INITP_04 : string;
attribute INITP_05 : string;
attribute INITP_06 : string;
attribute INITP_07 : string;
attribute xc_props : STRING;
--
-- Attributes to define ROM contents during implementation synthesis.
--
attribute INIT_00 of ram_1024_x_18 : label is  "DF01501EDF01502DDF015184DF01501DDF015344DF01501CDF014000600363B5";
attribute INIT_01 of ram_1024_x_18 : label is  "3FD263B54000400040005090DF01508EDF01505BDF015052DF015038DF015047";
attribute INIT_02 of ram_1024_x_18 : label is  "9DE01DF561A943B01FB063B01FB861915423DDCF3FE863B59DD01DF83FD363B5";
attribute INIT_03 of ram_1024_x_18 : label is  "1FE89D981DE861C63FD663B53FD563B543B01FB063B01FB8542FDDDF63B01FE8";
attribute INIT_04 of ram_1024_x_18 : label is  "63B01FB861F93FD463B53FD363B53FD263B543B01FD163B01FD0543EDD9763B0";
attribute INIT_05 of ram_1024_x_18 : label is  "63B53FD363B53FD263B543B01FB063B01FB8620C3FD363B53FD263B543B01FB0";
attribute INIT_06 of ram_1024_x_18 : label is  "63B50EF863B50DF863B50CF863B513F863B512F863B511F863B510F863B53FD4";
attribute INIT_07 of ram_1024_x_18 : label is  "63B506F863B505F863B504F863B50BF863B50AF863B509F863B508F863B50FF8";
attribute INIT_08 of ram_1024_x_18 : label is  "43B0625D43B01FB063B01FB8621D03F863B502F863B501F863B500F863B507F8";
attribute INIT_09 of ram_1024_x_18 : label is  "0E540F76089809BA0ADC0BFE04EF05CD06AB0789006701450223030143B06299";
attribute INIT_0A of ram_1024_x_18 : label is  "3F707FFF1F3057F8375817383F787FFF1F381D1410C311D212E113F00C100D32";
attribute INIT_0B of ram_1024_x_18 : label is  "979954F8344014203F607FFF1F2055F8354815283F687FFF1F2856F836501630";
attribute INIT_0C of ram_1024_x_18 : label is  "7568754815287670765016307778775817381D1454A7DD016117B45AB582B679";
attribute INIT_0D of ram_1024_x_18 : label is  "57F83F781F38375817381D1454C7DD016117B46EB5D9B6EB97A1746074401420";
attribute INIT_0E of ram_1024_x_18 : label is  "55F83F681F283548152856F83F701F5056F83F701F303650163057F83F781F58";
attribute INIT_0F of ram_1024_x_18 : label is  "6117B48FB51BB6BC97DC54F83F601F4054F83F601F203440142055F83F681F48";
attribute INIT_10 of ram_1024_x_18 : label is  "97D67460744014207568754815287670765016307778775817381D1454DBDD01";
attribute INIT_11 of ram_1024_x_18 : label is  "0F581060116812701378B480B588B690979840005503DD016117B4CAB562B6C1";
attribute INIT_12 of ram_1024_x_18 : label is  "082009280A300B385524DE0187088608850884088702870C1E020C400D480E50";
attribute INIT_13 of ram_1024_x_18 : label is  "A0A0A1A8A2B083B85535DE01A30080008100820083061E050400050806100718";
attribute INIT_14 of ram_1024_x_18 : label is  "74F81F8875F81F8976F81F8A77F81F8BA0A0A1A8A2B083B81480158116821783";
attribute INIT_15 of ram_1024_x_18 : label is  "74F81FB475F81FB576F81FB677F81FB774F81FA075F81FA176F81FA277F81FA3";
attribute INIT_16 of ram_1024_x_18 : label is  "34BC35BD36BE37BF5566DEBB3FF0DE041FF09EC01EC4B7009400950096009706";
attribute INIT_17 of ram_1024_x_18 : label is  "DE0177315D7F970677805D7C9F0C1E083FE863699DC81DF8170063731F334000";
attribute INIT_18 of ram_1024_x_18 : label is  "558CDD0163B063691D98636A1F00636A1F00636A1FF0637240005575DDC75579";
attribute INIT_19 of ram_1024_x_18 : label is  "61BA1FE89DD01DF8636A61BA1FD3636A61BA1FD217201602636A1F0F63724000";
attribute INIT_1A of ram_1024_x_18 : label is  "9DE01DF517FE1601636A1FAA637241BA7FFF636961BA7FFF6369559DDDCF636A";
attribute INIT_1B of ram_1024_x_18 : label is  "9600970676805DBE9F0C1E087FFF636961BA7FFF636955AFDDDF61BA3FE86369";
attribute INIT_1C of ram_1024_x_18 : label is  "61BA1FD6636A61BA1FD517DE1603636A1FA56372400055BBDE01770576805DC3";
attribute INIT_1D of ram_1024_x_18 : label is  "1700160036D137D061BA7FFF636961BA7FFF636955D2DD0161BA63691D21636A";
attribute INIT_1E of ram_1024_x_18 : label is  "636961BA7FFF636955E6DD933FE861BA63699D941DEC55E1DD0163A61BFA1D08";
attribute INIT_1F of ram_1024_x_18 : label is  "636A1FD3636A1FD2636A1F5A637240003F9763693F9663693695379461BA7FFF";
attribute INIT_20 of ram_1024_x_18 : label is  "1FD2636A1F336372400016F8636917F863695603DD0163A61BFA1D28636A1FD4";
attribute INIT_21 of ram_1024_x_18 : label is  "636A1F556372400016F8636917F863695614DD0163A61BFA1D30636A1FD3636A";
attribute INIT_22 of ram_1024_x_18 : label is  "1F88636A1F90636A1F985627DD0163A61BFA1D08636A1FD4636A1FD3636A1FD2";
attribute INIT_23 of ram_1024_x_18 : label is  "1F48636A1F50636A1F58636A1F60636A1F68636A1F70636A1F78636A1F80636A";
attribute INIT_24 of ram_1024_x_18 : label is  "1F08636A1F10636A1F18636A1F20636A1F28636A1F30636A1F38636A1F40636A";
attribute INIT_25 of ram_1024_x_18 : label is  "1F003FD21F80400016F8636917F863695654DD0163A61BFA1D28636A1F00636A";
attribute INIT_26 of ram_1024_x_18 : label is  "1F0F3FCE1F0E3FCD1F0D3FCC1F0C3FCB1F0B3FCA1F0A3FC91F093FC81F083FD3";
attribute INIT_27 of ram_1024_x_18 : label is  "3FC81FC03FD31F003FD21F80617161F93FD41F5F3FD31F003FD21F8061913FCF";
attribute INIT_28 of ram_1024_x_18 : label is  "1F0061913FCF1FC73FCE1FC63FCD1FC53FCC1FC43FCB1FC33FCA1FC23FC91FC1";
attribute INIT_29 of ram_1024_x_18 : label is  "1F0A3F811F093F801F086326617140005FB01FB876AA77AA620C3FD31F003FD2";
attribute INIT_2A of ram_1024_x_18 : label is  "3FA91FC13FA83F3F1FC03FB31F0F3FB21F0E3FB11F0D3FB01F0C3F831F0B3F82";
attribute INIT_2B of ram_1024_x_18 : label is  "1F003FD21F8060923FAF1FC73FAE1FC63FAD1FC53FAC1FC43FAB1FC33FAA1FC2";
attribute INIT_2C of ram_1024_x_18 : label is  "2DB22EB12FB030833182328133806326619156C2DDCF3FE81F039DD01DF83FD3";
attribute INIT_2D of ram_1024_x_18 : label is  "1FC63FAE1FC53FAD1FC43FAC1FC33FAB1FC23FAA1FC13FA91FC03FA81F402CB3";
attribute INIT_2E of ram_1024_x_18 : label is  "1F9157F87F081F9217F87F001F9361C660923FB61FCE3FB51FCD3FB41FCC3FAF";
attribute INIT_2F of ram_1024_x_18 : label is  "7F381F8C57F87F301F8D57F87F281F8E57F87F201F8F57F87F181F9057F87F10";
attribute INIT_30 of ram_1024_x_18 : label is  "57F87F601F8757F87F581F8857F87F501F8957F87F481F8A57F87F401F8B57F8";
attribute INIT_31 of ram_1024_x_18 : label is  "1F8157F87F881F8257F87F801F8357F87F781F8457F87F701F8557F87F681F86";
attribute INIT_32 of ram_1024_x_18 : label is  "3FA63FA53FA41FFF5728DEBF3FF09EC01EC01F0040005FB87F981F8057F87F90";
attribute INIT_33 of ram_1024_x_18 : label is  "63566356635663561FFF40003FBF1FB83FBE1F013FB71F803FB63FB53FB43FA7";
attribute INIT_34 of ram_1024_x_18 : label is  "574C3BD837F81F02C0011BF0170163A61B0F639C63A563A44356635663566356";
attribute INIT_35 of ram_1024_x_18 : label is  "940C140263A61B0E639C639F63A15F639F029F0C400063B01FB8633C1F3C63A5";
attribute INIT_36 of ram_1024_x_18 : label is  "6385638563856385638563851FFF439C9F0E63A61B3C63AB63A143A61B2D9F08";
attribute INIT_37 of ram_1024_x_18 : label is  "577C3BD837B01602C0011B18170163A61B02639C63A61B3063AB1FCC43856385";
attribute INIT_38 of ram_1024_x_18 : label is  "538E3BD863AB578B3BD8C0011B0163A15F979F029F0C40001FB8636A63A61B18";
attribute INIT_39 of ram_1024_x_18 : label is  "63AB4000350215019F0E63A61B0663AB63A143A61B049F08940C140263A2639C";
attribute INIT_3A of ram_1024_x_18 : label is  "C001DB014000350215004000C00057A73BD8C0011BF063AB43A61B01639C43A2";
attribute INIT_3B of ram_1024_x_18 : label is  "00000000000000000000000040001F0053B53C021C0140003F0053B03C011C01";
attribute INIT_3C of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3D of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3E of ram_1024_x_18 : label is  "0000000000000000000000000000000000000000000000000000000000000000";
attribute INIT_3F of ram_1024_x_18 : label is  "43AE000000000000000000000000000000000000000000000000000000000000";
attribute INITP_00 of ram_1024_x_18 : label is "DDDDDDDDDDDDDDDEEEF77BBDDEEEFBB3C3BBDDCF0F77CF0BBAB333333333333F";
attribute INITP_01 of ram_1024_x_18 : label is "C015555555555555554CC01555554CC015455455455440000000000FFDDDDDDD";
attribute INITP_02 of ram_1024_x_18 : label is "0E38F032AACCC0AA66666666666655AA55C2A85555CAAA1555556CC01555554C";
attribute INITP_03 of ram_1024_x_18 : label is "EECEBBACF3CFC3300ACF3CF3EF833B03A383CF3F00CF3CF3F0FBE0CECF3333B3";
attribute INITP_04 of ram_1024_x_18 : label is "A88F888EAAAAAAAA2277CC37777777777777777777730EEECE77CC3BB39DF30E";
attribute INITP_05 of ram_1024_x_18 : label is "65965965965BEAAAAAAAAAA2AAABF38223AAAAAAA8AAAAAAAABE50E23AAAAAAA";
attribute INITP_06 of ram_1024_x_18 : label is "D6C33CCFFFF3B3F2ACFFAB73D6C33FFFFF2888AAA8CC09659659659659659659";
attribute INITP_07 of ram_1024_x_18 : label is "C0000000000000000000000000000000000ACAB28A2F73CFE8B3F2AFDF73EA7C";
attribute xc_props of ram_1024_x_18 : label is "WRITE_MODE_A=READ_FIRST,WRITE_MODE_B=READ_FIRST";
--
begin
--
  --Instantiate the Xilinx primitive for a block RAM
  ram_1024_x_18: RAMB16_S9_S18
  --synthesis translate_off
  --translate_off
  --INIT values repeated to define contents for functional simulation
  generic map (INIT_00 => X"DF01501EDF01502DDF015184DF01501DDF015344DF01501CDF014000600363B5",
               INIT_01 => X"3FD263B54000400040005090DF01508EDF01505BDF015052DF015038DF015047",
               INIT_02 => X"9DE01DF561A943B01FB063B01FB861915423DDCF3FE863B59DD01DF83FD363B5",
               INIT_03 => X"1FE89D981DE861C63FD663B53FD563B543B01FB063B01FB8542FDDDF63B01FE8",
               INIT_04 => X"63B01FB861F93FD463B53FD363B53FD263B543B01FD163B01FD0543EDD9763B0",
               INIT_05 => X"63B53FD363B53FD263B543B01FB063B01FB8620C3FD363B53FD263B543B01FB0",
               INIT_06 => X"63B50EF863B50DF863B50CF863B513F863B512F863B511F863B510F863B53FD4",
               INIT_07 => X"63B506F863B505F863B504F863B50BF863B50AF863B509F863B508F863B50FF8",
               INIT_08 => X"43B0625D43B01FB063B01FB8621D03F863B502F863B501F863B500F863B507F8",
               INIT_09 => X"0E540F76089809BA0ADC0BFE04EF05CD06AB0789006701450223030143B06299",
               INIT_0A => X"3F707FFF1F3057F8375817383F787FFF1F381D1410C311D212E113F00C100D32",
               INIT_0B => X"979954F8344014203F607FFF1F2055F8354815283F687FFF1F2856F836501630",
               INIT_0C => X"7568754815287670765016307778775817381D1454A7DD016117B45AB582B679",
               INIT_0D => X"57F83F781F38375817381D1454C7DD016117B46EB5D9B6EB97A1746074401420",
               INIT_0E => X"55F83F681F283548152856F83F701F5056F83F701F303650163057F83F781F58",
               INIT_0F => X"6117B48FB51BB6BC97DC54F83F601F4054F83F601F203440142055F83F681F48",
               INIT_10 => X"97D67460744014207568754815287670765016307778775817381D1454DBDD01",
               INIT_11 => X"0F581060116812701378B480B588B690979840005503DD016117B4CAB562B6C1",
               INIT_12 => X"082009280A300B385524DE0187088608850884088702870C1E020C400D480E50",
               INIT_13 => X"A0A0A1A8A2B083B85535DE01A30080008100820083061E050400050806100718",
               INIT_14 => X"74F81F8875F81F8976F81F8A77F81F8BA0A0A1A8A2B083B81480158116821783",
               INIT_15 => X"74F81FB475F81FB576F81FB677F81FB774F81FA075F81FA176F81FA277F81FA3",
               INIT_16 => X"34BC35BD36BE37BF5566DEBB3FF0DE041FF09EC01EC4B7009400950096009706",
               INIT_17 => X"DE0177315D7F970677805D7C9F0C1E083FE863699DC81DF8170063731F334000",
               INIT_18 => X"558CDD0163B063691D98636A1F00636A1F00636A1FF0637240005575DDC75579",
               INIT_19 => X"61BA1FE89DD01DF8636A61BA1FD3636A61BA1FD217201602636A1F0F63724000",
               INIT_1A => X"9DE01DF517FE1601636A1FAA637241BA7FFF636961BA7FFF6369559DDDCF636A",
               INIT_1B => X"9600970676805DBE9F0C1E087FFF636961BA7FFF636955AFDDDF61BA3FE86369",
               INIT_1C => X"61BA1FD6636A61BA1FD517DE1603636A1FA56372400055BBDE01770576805DC3",
               INIT_1D => X"1700160036D137D061BA7FFF636961BA7FFF636955D2DD0161BA63691D21636A",
               INIT_1E => X"636961BA7FFF636955E6DD933FE861BA63699D941DEC55E1DD0163A61BFA1D08",
               INIT_1F => X"636A1FD3636A1FD2636A1F5A637240003F9763693F9663693695379461BA7FFF",
               INIT_20 => X"1FD2636A1F336372400016F8636917F863695603DD0163A61BFA1D28636A1FD4",
               INIT_21 => X"636A1F556372400016F8636917F863695614DD0163A61BFA1D30636A1FD3636A",
               INIT_22 => X"1F88636A1F90636A1F985627DD0163A61BFA1D08636A1FD4636A1FD3636A1FD2",
               INIT_23 => X"1F48636A1F50636A1F58636A1F60636A1F68636A1F70636A1F78636A1F80636A",
               INIT_24 => X"1F08636A1F10636A1F18636A1F20636A1F28636A1F30636A1F38636A1F40636A",
               INIT_25 => X"1F003FD21F80400016F8636917F863695654DD0163A61BFA1D28636A1F00636A",
               INIT_26 => X"1F0F3FCE1F0E3FCD1F0D3FCC1F0C3FCB1F0B3FCA1F0A3FC91F093FC81F083FD3",
               INIT_27 => X"3FC81FC03FD31F003FD21F80617161F93FD41F5F3FD31F003FD21F8061913FCF",
               INIT_28 => X"1F0061913FCF1FC73FCE1FC63FCD1FC53FCC1FC43FCB1FC33FCA1FC23FC91FC1",
               INIT_29 => X"1F0A3F811F093F801F086326617140005FB01FB876AA77AA620C3FD31F003FD2",
               INIT_2A => X"3FA91FC13FA83F3F1FC03FB31F0F3FB21F0E3FB11F0D3FB01F0C3F831F0B3F82",
               INIT_2B => X"1F003FD21F8060923FAF1FC73FAE1FC63FAD1FC53FAC1FC43FAB1FC33FAA1FC2",
               INIT_2C => X"2DB22EB12FB030833182328133806326619156C2DDCF3FE81F039DD01DF83FD3",
               INIT_2D => X"1FC63FAE1FC53FAD1FC43FAC1FC33FAB1FC23FAA1FC13FA91FC03FA81F402CB3",
               INIT_2E => X"1F9157F87F081F9217F87F001F9361C660923FB61FCE3FB51FCD3FB41FCC3FAF",
               INIT_2F => X"7F381F8C57F87F301F8D57F87F281F8E57F87F201F8F57F87F181F9057F87F10",
               INIT_30 => X"57F87F601F8757F87F581F8857F87F501F8957F87F481F8A57F87F401F8B57F8",
               INIT_31 => X"1F8157F87F881F8257F87F801F8357F87F781F8457F87F701F8557F87F681F86",
               INIT_32 => X"3FA63FA53FA41FFF5728DEBF3FF09EC01EC01F0040005FB87F981F8057F87F90",
               INIT_33 => X"63566356635663561FFF40003FBF1FB83FBE1F013FB71F803FB63FB53FB43FA7",
               INIT_34 => X"574C3BD837F81F02C0011BF0170163A61B0F639C63A563A44356635663566356",
               INIT_35 => X"940C140263A61B0E639C639F63A15F639F029F0C400063B01FB8633C1F3C63A5",
               INIT_36 => X"6385638563856385638563851FFF439C9F0E63A61B3C63AB63A143A61B2D9F08",
               INIT_37 => X"577C3BD837B01602C0011B18170163A61B02639C63A61B3063AB1FCC43856385",
               INIT_38 => X"538E3BD863AB578B3BD8C0011B0163A15F979F029F0C40001FB8636A63A61B18",
               INIT_39 => X"63AB4000350215019F0E63A61B0663AB63A143A61B049F08940C140263A2639C",
               INIT_3A => X"C001DB014000350215004000C00057A73BD8C0011BF063AB43A61B01639C43A2",
               INIT_3B => X"00000000000000000000000040001F0053B53C021C0140003F0053B03C011C01",
               INIT_3C => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3D => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3E => X"0000000000000000000000000000000000000000000000000000000000000000",
               INIT_3F => X"43AE000000000000000000000000000000000000000000000000000000000000",    
               INITP_00 => X"DDDDDDDDDDDDDDDEEEF77BBDDEEEFBB3C3BBDDCF0F77CF0BBAB333333333333F",
               INITP_01 => X"C015555555555555554CC01555554CC015455455455440000000000FFDDDDDDD",
               INITP_02 => X"0E38F032AACCC0AA66666666666655AA55C2A85555CAAA1555556CC01555554C",
               INITP_03 => X"EECEBBACF3CFC3300ACF3CF3EF833B03A383CF3F00CF3CF3F0FBE0CECF3333B3",
               INITP_04 => X"A88F888EAAAAAAAA2277CC37777777777777777777730EEECE77CC3BB39DF30E",
               INITP_05 => X"65965965965BEAAAAAAAAAA2AAABF38223AAAAAAA8AAAAAAAABE50E23AAAAAAA",
               INITP_06 => X"D6C33CCFFFF3B3F2ACFFAB73D6C33FFFFF2888AAA8CC09659659659659659659",
               INITP_07 => X"C0000000000000000000000000000000000ACAB28A2F73CFE8B3F2AFDF73EA7C",
               WRITE_MODE_A => "READ_FIRST",
               WRITE_MODE_B => "READ_FIRST")
  --translate_on
  --synthesis translate_on
-- synthesis translate_on
  port map(   DIA => di(7 downto 0),
             DIPA => di(8 downto 8),
              ENA => '1',
              WEA => we,
             SSRA => '0',
             CLKA => nclk,
            ADDRA => wa,
              DOA => do(7 downto 0),
             DOPA => do(8 downto 8),
              DIB => "1111111111111111",
             DIPB => "11",
              ENB => '1',
              WEB => '0',
             SSRB => '0',
             CLKB => clk,
            ADDRB => address,
              DOB => instruction(15 downto 0),
             DOPB => instruction(17 downto 16)); 
--
end low_level_definition;
--
------------------------------------------------------------------------------------
--
-- END OF FILE sha2.vhd
--
------------------------------------------------------------------------------------
